
/*

  cpu main definitions

*/


#ifndef CPUCORE_H
#define CPUCORE_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

#include "m68k/m68k.h"
#include "makez80/mz80.h"
#include "ym2151/ym2151.h"
#include "okim6295/adpcm.h"
#include "eeprom/eeprom.h"
#include "romspace.h"
#include "video32.h"
#include "sound.h"
#include "gui.h"

void cps1cpucore_init(tRomSpace*);
void cps1cpucore_free();
void cps1cpucore_emulate(int);
void cps1cpucore_drawScreen(unsigned long int* video,tCharset* chset);

void cps2cpucore_init(tRomSpace*);
void cps2cpucore_free();
void cps2cpucore_emulate(int);
void cps2cpucore_drawScreen(unsigned long int* video,tCharset* chset);

/*
// helper functions

int READ_WORD(void *dst);
int specREAD8(unsigned char* mem,unsigned long int addr,unsigned long int base);
int specREAD16(unsigned char* mem,unsigned long int addr,unsigned long int base);
unsigned long int specREAD32(unsigned char* mem,unsigned long int addr,unsigned long int base);
void specWRITE8(unsigned char* mem,unsigned long int addr,unsigned long int base,unsigned long int val);
void specWRITE16(unsigned char* mem,unsigned long int addr,unsigned long int base,unsigned long int val);
void specWRITE32(unsigned char* mem,unsigned long int addr,unsigned long int base,unsigned long int val);
int READ8(unsigned char* mem,unsigned long int addr,unsigned long int base);
int READ16(unsigned char* mem,unsigned long int addr,unsigned long int base);
unsigned long int READ32(unsigned char* mem,unsigned long int addr,unsigned long int base);
void WRITE8(unsigned char* mem,unsigned long int addr,unsigned long int base,unsigned long int val);
void WRITE16(unsigned char* mem,unsigned long int addr,unsigned long int base,unsigned long int val);
void WRITE32(unsigned char* mem,unsigned long int addr,unsigned long int base,unsigned long int val);
void WRITE8opp(unsigned char* mem,unsigned long int addr,unsigned long int base,unsigned long int val);
void WRITE16opp(unsigned char* mem,unsigned long int addr,unsigned long int base,unsigned long int val);
void WRITE32opp(unsigned char* mem,unsigned long int addr,unsigned long int base,unsigned long int val);
*/

// extern function pointers

extern unsigned int (*m68kri16)(unsigned int address);
extern unsigned int (*m68kri32)(unsigned int address);
extern unsigned int (*m68krpc8)(unsigned int address);
extern unsigned int (*m68krpc16)(unsigned int address);
extern unsigned int (*m68krpc32)(unsigned int address);
extern unsigned int (*m68kr8)(unsigned int address);
extern unsigned int (*m68kr16)(unsigned int address);
extern unsigned int (*m68kr32)(unsigned int address);
extern void (*m68kw8)(unsigned int address, unsigned int value);
extern void (*m68kw16)(unsigned int address, unsigned int value);
extern void (*m68kw32)(unsigned int address, unsigned int value);

// cps1 memory functions

unsigned int cps1_m68kri16(unsigned int address);
unsigned int cps1_m68kri32(unsigned int address);
unsigned int cps1_m68krpc8(unsigned int address);
unsigned int cps1_m68krpc16(unsigned int address);
unsigned int cps1_m68krpc32(unsigned int address);
unsigned int cps1_m68kr8(unsigned int address);
unsigned int cps1_m68kr16(unsigned int address);
unsigned int cps1_m68kr32(unsigned int address);
void cps1_m68kw8(unsigned int address, unsigned int value);
void cps1_m68kw16(unsigned int address, unsigned int value);
void cps1_m68kw32(unsigned int address, unsigned int value);

// cps2 memory functions

unsigned int cps2_m68kri16(unsigned int address);
unsigned int cps2_m68kri32(unsigned int address);
unsigned int cps2_m68krpc8(unsigned int address);
unsigned int cps2_m68krpc16(unsigned int address);
unsigned int cps2_m68krpc32(unsigned int address);
unsigned int cps2_m68kr8(unsigned int address);
unsigned int cps2_m68kr16(unsigned int address);
unsigned int cps2_m68kr32(unsigned int address);
void cps2_m68kw8(unsigned int address, unsigned int value);
void cps2_m68kw16(unsigned int address, unsigned int value);
void cps2_m68kw32(unsigned int address, unsigned int value);

#endif