#ifndef EEPROM_H
#define EEPROM_H

#define CLEAR_LINE		0		/* clear (a fired, held or pulsed) line */
#define ASSERT_LINE     1       /* assert an interrupt immediately */
#define HOLD_LINE       2       /* hold interrupt line until enable is true */
#define PULSE_LINE		3		/* pulse interrupt line for one instruction */

#define UINT8 unsigned char

struct EEPROM_interface
{
	int address_bits;	
	int data_bits;		
	char *cmd_read;		
	char *cmd_write;	
	char *cmd_erase;	
	char *cmd_lock;		
	char *cmd_unlock;	
	int enable_multi_read;
};

void EEPROM_init(struct EEPROM_interface *interf);

void EEPROM_write_bit(int bit);
int EEPROM_read_bit(void);
void EEPROM_set_cs_line(int state);
void EEPROM_set_clock_line(int state);

void EEPROM_load(void *file);
void EEPROM_save(void *file);

void EEPROM_set_data(UINT8 *data, int length);

#endif
