/*

  gui
  the gui class

*/


#ifndef GUI_H
#define GUI_H

#include <windows.h>

#include <vector>

#include "font.h"
#include "component.h"
#include "video32.h"
#include "romspace.h"
#include "charset.h"
#include "cpucore.h"
#include "timing.h"
#include "video32.h"
#include "background.h"
#include "sysbar.h"
#include "menu.h"


// the class
// gui is the glue between different parts
// of the emulation system
// everything should interact with the gui
// and the gui should interact with everything


class tGui
{
private:

	tFont* font8x8;
	std::vector<tComponent*> compList;
	int action;

	int exitp;
	int state;			// is gui active?
	int guiXsize;
	int guiYsize;

	int openRom();

public:

	unsigned long int* videoBuf;
	int emulating;
	int romsettype;
	tRomSpace romset;
	tCharset* chset;
	guiInput ginput;

	tGui(int s,int gxs,int gys,char* f8x8name);
	~tGui();
	void redraw(unsigned long int* vbuf);
	void update();		// reparse input
	int exitprogram();

	void mouseMove(int x,int y);
	void lButtonDown();
	void lButtonUp();
	void rButtonDown();
	void rButtonUp();
};

#endif