
/*

  a.c.e.
  Another Capcom (Play System) Emulator
  v1.0

  12/5/2001

*/


#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

#include "component.h"
#include "background.h"
#include "sysbar.h"
#include "menu.h"
#include "video32.h"
#include "sound.h"
#include "romspace.h"
#include "charset.h"
#include "cpucore.h"
#include "timing.h"
#include "gui.h"

// the gui

tGui* gui;


/*extern int goshift;*/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	HWND wh;
	MSG msg;
	int exit=0;
	int frame=0;
	int fskp=1;
	int sound=0;

	// init gui

	gui=new tGui(0,SCRX,SCRY,"8x8.fnt");

	// init display

	if (initDisplay(nCmdShow,&wh,&gui->videoBuf,1)) 
	{
		MessageBox(NULL,"can't do video init","error",MB_OK);
		return 1;
	}

	// init timer

	init_timer();

	// init sound

	if (sound)
	{
		if (initSound(wh,44100))
		{
			MessageBox(NULL,"can't do sound init","error",MB_OK);
			freeDisplay(&gui->videoBuf);
			shutdownSound();
			delete gui;
			return 1;
		}
	}

	// main loop

	while (!exit)
	{
		if (gui->emulating!=0)
		{
			if (gui->romsettype==ROMSET_CPS1)
			{
				cps1cpucore_emulate(sound);
	//			if ((frame%fskp)==0) cpucore_drawScreen(gui->videoBuf,gui->chset);
				cps1cpucore_drawScreen(gui->videoBuf,gui->chset);
			}
			else if (gui->romsettype==ROMSET_CPS2)
			{
				cps2cpucore_emulate(sound);
	//			if ((frame%fskp)==0) cpucore_drawScreen(gui->videoBuf,gui->chset);
				cps2cpucore_drawScreen(gui->videoBuf,gui->chset);
			}

			gui->update();
			gui->redraw(gui->videoBuf);

			videoput32(gui->videoBuf);

			frame++;
			trim_speed();

/*
			int r,c;

			int chr=0;
			int nx=16;
			int ny=10;
			int dim=16;

			chr=0;
			for (r=0;r<ny;r++)
			{	
				for (c=0;c<nx;c++)
				{
					gui->chset->printSprite(
									gui->videoBuf,
									chr+goshift*nx,0,
									c*dim,r*dim,SCRX,SCRY,
									0,0);
					chr++;
				}
			}
			gui->update();
			gui->redraw(gui->videoBuf);
			videoput32(gui->videoBuf);
*/
		}
		else
		{
			gui->update();
			gui->redraw(gui->videoBuf);
			videoput32(gui->videoBuf);
		}

		if (PeekMessage(&msg, NULL,0,0,PM_NOREMOVE))
		{
			GetMessage (&msg, NULL, 0, 0);
			TranslateMessage (&msg);
			DispatchMessage (&msg);
		}

		if ( (msg.message==WM_QUIT) || (gui->exitprogram()) )
		{
			exit=1;
		}
	}

	// dispose video

	freeDisplay(&gui->videoBuf);

	// dispose cpu

	if (gui->romsettype==ROMSET_CPS1)
	{
		cps1cpucore_free();
	}
	else if (gui->romsettype==ROMSET_CPS2)
	{
		cps2cpucore_free();
	}

	// dispose soundz

	if (sound)
	{
		shutdownSound();
	}

	// dispose gui

	delete gui;

	// exit

	return (msg.wParam);
}
