
/*

  menu class

*/


#ifndef MENU_H
#define MENU_H

#include <string>
#include <vector>
#include "component.h"


class tMenuItem
{
private:
	std::string name;
	int fontcolor;
	int action;

public:
	int childMenu;

	tMenuItem();
	tMenuItem(std::string n,int childm,int fc,int act);
	void draw(unsigned long int* vbuf,int xp,int yp,int gxs,int gys,tFont* font);
	std::string getName();
	int getAction();

	operator==(const tMenuItem& o2) const { return 1; };
	operator<(const tMenuItem& o2) const { return 1; };
};

class tSubMenu: public tComponent
{
private:

	std::vector<tMenuItem> itemList;
	int action;

public:

	// left-bottom corner
	int xpos;
	int ypos;
	int highlightedItem;
	int activatedmenu;

	tSubMenu();
	tSubMenu(int xp,int yp,int col,int gxs,int gys,int act);

	int nItems();
	void addItem(tMenuItem &m);
	void draw(unsigned long int* vbuf,tFont* f8x8,guiInput* gi);
	int getAction();
	void resetAction();

	std::string getItem(int n);
	int getItemChildMenu(int n);

	void update(guiInput* gi);

	operator==(const tSubMenu& o2) const { return 1; };
	operator<(const tSubMenu& o2) const { return 1; };
};

class tMenu: public tComponent
{
private:
	std::vector<tSubMenu> menuList;
	int fontcolor;
	int action;

	void drawRect(int x1,int y1,int x2,int y2,int col,unsigned long int* vbuf);

public:

	tMenu(int fc,int gxs,int gys);
	void addItem(tSubMenu &sm);
	void update(guiInput* gi);
	void draw(unsigned long int* vbuf,tFont* f8x8,guiInput* gi);
	int getAction() { return action; }
	void resetAction();
	void deactivate();
};

#endif