
/* 

  rom definition and romsets

*/

#ifndef ROMS_H
#define ROMS_H


// rom loading type

#define ROM_LOAD_ODD 0
#define ROM_LOAD_EVEN 1
#define ROM_LOAD_WIDESWAP 2
#define ROM_LOAD_NORMAL 2
#define ROM_LOAD_SKIP6 4

// romset type

#define ROMSET_CPS1 0
#define ROMSET_CPS2 1

// the rom structure

struct tRom
{
	char name[32];
	unsigned long int size;
	unsigned long int position;
	unsigned long int loadtype;
};

// a romset

struct tRomSet
{
	char name[64];
	int romsettype;

	int nspr;
	int nchars;
	int ntile16;
	int ntile32;

	int sprmagic1,sprmagic2;
	int charmagic1;
	int tile16magic1,tile16magic2;
	int tile32magic1,tile32magic2;

	int sproffs,charoffs,tile16offs,tile32offs;
	int charbase,tile16base,tile32base;
	int charpad,tile16pad,tile32pad;

	unsigned long int protport,protval;
	unsigned long int multlo,multhi,fac1,fac2;
	int layercontrol;

	int ncoderoms;
	int ngfxroms;
	int nsndroms;

	tRom romlist[64];
};

#endif