/*

  timing.cpp

*/

#include <windows.h>
#include "timing.h"

static LARGE_INTEGER oldt;
static LARGE_INTEGER pfq;
static __int64 oneframe,pfq64;

void init_timer()
{
	BOOL rv;

	// check for high precision timer

	rv=QueryPerformanceFrequency(&pfq);
	if (rv==0)
	{
		MessageBox(0,"this machine does not support rdtsc","error",MB_OK);
	}

	pfq64=pfq.QuadPart;
	oneframe=pfq64/60;

	rv=QueryPerformanceCounter(&oldt);
	if (rv==0)
	{
		MessageBox(0,"this machine does not support rdtsc","error",MB_OK);
	}
}

void trim_speed()
{
	// see how much time is elapsed
	// between this call and the last one

	LARGE_INTEGER curt;
	__int64 curt64,oldt64;
	
	QueryPerformanceCounter(&curt);

	curt64=curt.QuadPart;
	oldt64=oldt.QuadPart;

	while ((curt64-oldt64)<oneframe)
	{
		QueryPerformanceCounter(&curt);
		curt64=curt.QuadPart;
	}

	oldt=curt;
}