
/*

  system bar

*/


#include "sysbar.h"


tSysbar::tSysbar(int col,int fontcol,int h,int gxs,int gys,int ds)
{
	menuclicked=0;
	menuover=0;
	fontcolor=fontcol;
	color=col;
	height=h;
	guiXsize=gxs;
	guiYsize=gys;
	active=1;
	doublesize=ds;
}

void tSysbar::update(guiInput* gi)
{
	// (for now) check mouse in the menu area

	int logox1,logox2,logoy1,logoy2;

	if (doublesize)
	{
		logox1=0;logox2=60;logoy2=guiYsize*2; logoy1=400;
	}
	else
	{
		logox1=0;logox2=30;logoy2=guiYsize; logoy1=190;
	}

	if ( (gi->mouseXpos>=logox1) && (gi->mouseXpos<=logox2) &&
		 (gi->mouseYpos>=logoy1) && (gi->mouseYpos<logoy2) )
	{
		menuover=1;

		if (gi->mousebutton1==1)
		{
			menuclicked=1;
			gi->mousebutton1=0;		//ack event (?)
		}
		else
		{
			menuclicked=0;
		}
	}
	else
	{
		menuover=0;
	}
}

void tSysbar::drawRect(int x1,int y1,int x2,int y2,int col,unsigned long int* vbuf)
{
	for (int r=y1;r<y2;r++)
	{
		for (int c=x1;c<x2;c++)
		{
			vbuf[r*guiXsize+c]=col;
		}
	}

}

void tSysbar::draw(unsigned long int* vbuf,tFont* f8x8,guiInput* gi)
{
	// height of the gui should be proportional
	// to screen dimension
	// ...

	// the lower rectangle
	for (int i=((guiYsize-height)*guiXsize);i<(guiXsize*guiYsize);i++)
	{
		int r1,g1,b1;

		r1=color&0xff; g1=(color>>8)&0xff; b1=(color>>16)&0xff;
		vbuf[i]=r1|(g1<<8)|(b1<<16);
	}

	// the upper line
	for (i=((guiYsize-height)*guiXsize);i<((guiYsize-height)*guiXsize+guiXsize);i++)
	{
		int r1,g1,b1;

		r1=clamp((color&0xff)+20);
		g1=clamp(((color>>8)&0xff)+20);
		b1=clamp(((color>>16)&0xff)+20);
		vbuf[i]=r1|(g1<<8)|(b1<<16);
	}

	// the logo! and the version
	// should we enlight the logo?

	if (menuover)
	{
		// draw the rectangle under "ace" logo
		drawRect(2,guiYsize-height+1,28,guiYsize,0x424282,vbuf);
	}

	f8x8->drawString("Ace",fontcolor,3,guiYsize-height+2,guiXsize,guiYsize,vbuf);
	f8x8->drawString("gui v1.0",fontcolor,guiXsize-68,guiYsize-height+2,guiXsize,guiYsize,vbuf);

/*
	int mxp,myp;
	char smxp[10];
	char smyp[10];
	char fs[256];

	mxp=gi->mouseXpos;
	myp=gi->mouseYpos;

	sprintf(smxp,"%d",mxp);
	sprintf(smyp,"%d",myp);

	sprintf(fs,"%s %s",smxp,smyp);

	f8x8->drawString(fs,fontcolor,guiXsize-128,guiYsize-height+2,guiXsize,guiYsize,vbuf);
*/
}
