/*

  where the fun starts
  (the fun?)

*/

#include "cpucore.h"

// a68k

struct m68k_memory_interface a68k_memory_intf;
unsigned char *OP_ROM=NULL,*OP_RAM=NULL;
int m68k_ICount=0;
unsigned int mem_amask=0xffffff;
unsigned int mame_debug=0,cur_mrhard=0,m68k_illegal_opcode=0,illegal_op=0,illegal_pc=0,opcode_entry=0;

// read/write handlers pointers
// will switch this to classes soon, don't worry

unsigned int (*m68kri16)(unsigned int address);
unsigned int (*m68kri32)(unsigned int address);
unsigned int (*m68krpc8)(unsigned int address);
unsigned int (*m68krpc16)(unsigned int address);
unsigned int (*m68krpc32)(unsigned int address);
unsigned int (*m68kr8)(unsigned int address);
unsigned int (*m68kr16)(unsigned int address);
unsigned int (*m68kr32)(unsigned int address);
void (*m68kw8)(unsigned int address, unsigned int value);
void (*m68kw16)(unsigned int address, unsigned int value);
void (*m68kw32)(unsigned int address, unsigned int value);

//
// read-write handlers
//

unsigned int m68k_read_immediate_16(unsigned int address)
{
	return m68kri16(address);
}

unsigned int m68k_read_immediate_32(unsigned int address)
{
	return m68kri32(address);
}

unsigned int m68k_read_pcrelative_8(unsigned int address)
{
	return m68krpc8(address);
}

unsigned int m68k_read_pcrelative_16(unsigned int address)
{
	return m68krpc16(address);
}

unsigned int m68k_read_pcrelative_32(unsigned int address)
{
	return m68krpc32(address);
}

unsigned int m68k_read_memory_8(unsigned int address)
{
	return m68kr8(address);
}

unsigned int  m68k_read_memory_16(unsigned int address)
{
	return m68kr16(address);
}

unsigned int  m68k_read_memory_32(unsigned int address)
{
	return m68kr32(address);
}

void m68k_write_memory_8(unsigned int address, unsigned int value)
{
	m68kw8(address,value);
}

void m68k_write_memory_16(unsigned int address, unsigned int value)
{
	m68kw16(address,value);
}

void m68k_write_memory_32(unsigned int address, unsigned int value)
{
	m68kw32(address,value);
}
