/*

lsd.c

the italian gti.
(c) icl warez 2k
"don't expect too much from the end of the world" (tm)

*/


/*

Function        :       ltrim
Purpose         :       deletes every initial blank space from a given string.
                        we suppose the string to be null terminated.
Parameters      :       str     -       text string (IN) (OUT)                  
Returns         :       0.
Notes           :       

*/

int ltrim(unsigned char* str)
{
    int found=0;
    unsigned char* pstr=str;

    while (found==0)
    {
        if (*pstr==' ')
        {
            pstr++;
        }
        else found=1;
    }

    strcpy(str,pstr);

    return 0;
}

/*

Function        :       rtrim
Purpose         :       see ltrim
Parameters      :       str     -       text string (IN) (OUT)
Returns         :       0.
Notes           :       none.

*/

int rtrim(unsigned char* str)
{
    unsigned int sl;
    unsigned int pos;
    int found=0;

    sl=strlen(str);
    if (sl==0) return 0;

    pos=sl-1;

    while ( (found==0) && (pos>0) )
    {
        if ( (str[pos]==' ') || (str[pos]==0x0a) )
        {
            str[pos]='\0';
            pos--;
        }
        else
        {
            found=1;
        }
    }

    return 0;
}

/*

Function        :       getParameter
Purpose         :       given a text file (like prospero.ini),a section name (like "[Database]")
                                and a parameter name (like "Username") scans the text file and returns in
                                paramvalue a string containing the value of the parameter in the specified
                                section.we suppose paramvalue is an *allocated* string.
                                the function skips any line beginning with ";" (comment)
Parameters      :       filename        -       the name of the file to search in (IN)
                                sectionname     -       the name of the section           (IN)
                                paramname       -       the name of the parameter to search for (IN)
                                paramvalue      -       string with the parameter value if found (OUT)
Returns         :       0 if OK,1 if error.
Notes           :       

*/

int getParameter(unsigned char* filename,char* sectionname,
                 char* paramname,unsigned char* paramvalue)
{
    FILE* inifile;
    int sectionFound=0;
    int paramFound=0;
    int goOut=0;
    int error;

    if ( (filename==NULL) || (sectionname==NULL) || (paramname==NULL) || (paramvalue==NULL) ) return 1;

    inifile=fopen(filename,"rb");
    if (inifile==NULL) return 1;

    /* scan the file until you don't find a matching section or until it ends */
    while (!goOut)
    {
        unsigned char line[256];
        unsigned char* bufptr;
        
        bufptr=(unsigned char*)fgets((unsigned char*)line,256,inifile);
        if (bufptr==NULL)
        {
            goOut=1;
        }
        else
        {
            /* rtrim and ltrim the line found */
            ltrim(line);
            rtrim(line);
                
            /* check if it's a comment */
            if (line[0]==';') ;
            else
            {
                /* check if it's a section and matches */
                if (!strcmp(line,sectionname))
                {
                    sectionFound=1;
                    /* printf("trovata la sezione %s\n",line); */
                    goOut=1;
                }
            }
        }
    }

    if (sectionFound!=0)
    {
        goOut=0;
        
        while (!goOut)
        {
            /*
               scan the inifile until:
               1) it ends
               2) you find "[" (another section)
               3) you find the parameter
            */
        
            unsigned char line[256];
            unsigned char* bufptr;
        
            bufptr=(unsigned char*)fgets(line,256,inifile);
            if (bufptr==NULL)
            {
                goOut=1;
                /* printf("eof?\n"); */
            }
            else
            {
                /* rtrim and ltrim the line found */
                ltrim(line);
                rtrim(line);
                
                /* printf("line trimmed\n"); */
                
                /* check if it's a comment */
                if (line[0]==';') ;
                if (line[0]=='[')
                {
                    goOut=1;
                }
                else
                {
                    /* check if there's a parameter and if it matches */
                    unsigned char lvalue[256];
                    unsigned char rvalue[256];
                    unsigned char* eqptr;
                
                    eqptr=(unsigned char*)strstr(line,"=");
                    if (eqptr==NULL)
                    {
                        /* skip the line (it would be a syntax error really) */
                    }
                    else
                    {
                        strcpy(rvalue,eqptr+1);
                        *eqptr='\0';
                        strcpy(lvalue,line);
                        
                        ltrim(lvalue); rtrim(lvalue);
                        ltrim(rvalue); rtrim(rvalue);
                        
                        /* printf("rtrimmed\n"); */
                        /* printf("paramname:%s lvalue:%s\n",paramname,lvalue); */
                        
                        /* is it our parameter? */
                        if (!strcmp(paramname,lvalue))
                        {
                            /* allocate paramvalue */
                        
                            strcpy(paramvalue,rvalue);
                            goOut=1;
                            paramFound=1;
                        }
                    }
                }
            }
        
        }
    }

    fclose(inifile);
    return 0;
}
