/*

	charset encapsulation
	(in spite of encapsulation)

*/

#ifndef CHARSET_H
#define CHARSET_H

#include <stdlib.h>
#include <string.h>
#include "video32.h"

#define CHARSET_CPS1 1
#define CHARSET_CPS2 2


class tCharset
{
private:

	int chtype;

public:

	// place to store undecoded cps2 gfx
	unsigned char* gfxrom;

	// palette is word32-padded for speed
	unsigned char palette[32*32*8*4];

	// rowscroll offsets
	int rowscroll[1024];

	unsigned char** sprites;
	unsigned char** chars;
	unsigned char** tiles16;
	unsigned char** tiles32;

	int sproffs,charoffs,tile16offs,tile32offs;
	int nSprites,nChars,nTiles16,nTiles32;

	tCharset(int,int,int,int,int type);
	~tCharset();

	void printSprite(unsigned long int*,int,int,int,int,int,int);
	void printChar(unsigned long int*,int,int,int,int,int,int);
	void printTile16(unsigned long int*,int,int,int,int,int,int);
	void printTile16rs(unsigned long int*,int,int,int,int,int,int,int*,int);
	void printTile32(unsigned long int*,int,int,int,int,int,int);

	void cps2printSprite(unsigned long int*,int,int,int,int,int,int);
	void cps2printChar(unsigned long int*,int,int,int,int,int,int);
	void cps2printTile16(unsigned long int*,int,int,int,int,int,int);
	void cps2printTile16rs(unsigned long int*,int,int,int,int,int,int,int);
	void cps2printTile32(unsigned long int*,int,int,int,int,int,int);
};

#endif