
/*

  cpu main definitions

*/


#ifndef CPUCORE_H
#define CPUCORE_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

#include "a68k/a68k.h"
#include "makez80/mz80.h"
#include "ym2151/ym2151.h"
#include "okim6295/adpcm.h"
#include "qsound/qsound.h"
#include "eeprom/eeprom.h"
#include "romspace.h"
#include "video32.h"
#include "sound.h"
#include "gui.h"

void cps1cpucore_init(tRomSpace*);
void cps1cpucore_free();
void cps1cpucore_emulate(int);
void cps1cpucore_drawScreen(unsigned long int* video,tCharset* chset);

void cps2cpucore_init(tRomSpace*);
void cps2cpucore_free();
void cps2cpucore_emulate(int);
void cps2cpucore_drawScreen(unsigned long int* video,tCharset* chset);

// cps1 memory functions

unsigned char cps1_m68kr8(int address);
unsigned short int cps1_m68kr16(int address);
unsigned long int cps1_m68kr32(int address);
void cps1_m68kw8(int address, unsigned char value);
void cps1_m68kw16(int address, unsigned short int value);
void cps1_m68kw32(int address, unsigned long int value);


// cps2 memory functions

unsigned short int cps2_m68kri16(int address);
unsigned long int cps2_m68kri32(int address);
unsigned char cps2_m68krpc8(int address);
unsigned short int cps2_m68krpc16(int address);
unsigned long int cps2_m68krpc32(int address);
unsigned char cps2_m68kr8(int address);
unsigned short int cps2_m68kr16(int address);
unsigned long int cps2_m68kr32(int address);
void cps2_m68kw8(int address, unsigned char value);
void cps2_m68kw16(int address, unsigned short int value);
void cps2_m68kw32(int address, unsigned long int value);

#endif