/*

  the romspace

*/

#ifndef ROMSPACE_H
#define ROMSPACE_H

#include "unzip.h"
#include "charset.h"
#include "roms.h"


// the romspace

class tRomSpace
{
private:

	void readError(char* zipfile,char* romfile);
	int loadZippedRom(char* zipfile,char* romfile,unsigned long int size,unsigned char* dest);
	int romsetByName(char* romsetname,int* rs);
	unsigned long int getGromSize(tRomSet* rsp);
	int loadRomSet(tRomSet* rs);

	int readbit(const unsigned char *src,int bitnum);
	void decodesprites(int num,unsigned char *src,unsigned char** dest);
	void decodechars(int num,unsigned char *src,unsigned char** dest);
	void decodetiles16(int num,unsigned char *src,unsigned char** dest);
	void decodetiles32(int num,unsigned char *src,unsigned char** dest);
	void cps2decodesprites(int num,unsigned char *src,unsigned char** dest);
	void cps2decodechars(int num,unsigned char *src,unsigned char** dest);
	void cps2decodetiles16(int num,unsigned char *src,unsigned char** dest);
	void cps2decodetiles32(int num,unsigned char *src,unsigned char** dest);
	void cps1_gfx_decode(unsigned char*);
	void unshuffle(__int64 *buf,int len);

public:

	unsigned char* romCPU1;
	unsigned char* romCPU2;
	unsigned char* romadpcm;
	unsigned char* romqsound;

	char romname[64];
	int romsettype;
	int orientation;
	int kludge;
	unsigned long int gromsize;

	int nspr;
	int nchars;
	int ntile16;
	int ntile32;

	int sprmagic1,sprmagic2;
	int charmagic1;
	int tile16magic1,tile16magic2;
	int tile32magic1,tile32magic2;

	int sproffs,charoffs,tile16offs,tile32offs;
	int charbase,tile16base,tile32base;
	int charpad,tile16pad,tile32pad;

	unsigned long int protport,protval;
	unsigned long int multlo,multhi,fac1,fac2;
	int layercontrol;

	tRomSpace();
	~tRomSpace();
	int readRoms(char* path,char* romsetname,tCharset**);
	void decodeCharset(tCharset*,int rst);
} ;


#endif