
/*

  the cps1 machine

*/


#ifndef CPS1CPUCORE_H
#define CPS1CPUCORE_H

#include "cpucore.h"

class cps1cpucore: public cpucore
{
private:

	int drawlayer[3]; // draw layers?
	int kludge;

	char romname[64];
	int charbase,tile16base,tile32base;
	int charpad,tile16pad,tile32pad;
	int layercontrol;

	int sndbufsize;
	OKIM6295interface okim;
	int snddivider;
	short int* psndbuf[2];

	// memory regions

	unsigned char* romadpcm;

	short int* sndbuf[2];
	short int* tempsoundbuf;
	short int* realsoundbuf;
	short int* okimsoundbuf[2];

	// z80
	
	CONTEXTMZ80 ctx1;

public:

	cps1cpucore(tRomSpace* roms);
	~cps1cpucore();

	void a68kReset();
	void emulate(int snd);
	void update_controls();
	void build_palette(tCharset* chset);
	void drawScroll1(unsigned long int* video,tCharset* chset);
	void drawScroll2(unsigned long int* video,tCharset* chset);
	void drawScroll2rs(unsigned long int* video,tCharset* chset);
	void drawScroll3(unsigned long int* video,tCharset* chset);
	void drawSprites(unsigned long int* video,tCharset* chset);
	void draw_layer(int l,unsigned long int* video,tCharset* chset);
	void checkquickstate();
	void drawScreen(unsigned long int* video,tCharset* chset);
};

#endif