
/*

 data file module (for ROM managers)
 by logiqx

*/

#include "roms.h"
#include "dat.h"

extern const char* appName;
extern tRomSet romsetList[];

int write_datfile(int nDatType)
{
	char cFilename[80];
	char cVersion[10];
	char cParentName[64];
	char cParentDescr[256];
	FILE *fDat=0;
	int i, j, nNumRoms, nFoundParent;
	int nRet=0;

	strncpy(cVersion, strchr(appName, 'v'), 9);
	*strchr(cVersion, ' ')='\0';
/*
	if (nDatType==0)
		sprintf(cFilename, "ACE %s (CMPro).dat", cVersion);
	else
		sprintf(cFilename, "ACE %s (RomCenter).dat", cVersion);
*/

	sprintf(cFilename, "ACE %s.dat", cVersion);

	if ((fDat=fopen(cFilename, "w"))==0)
		return -1;
 
	if (nDatType==0)
	{
		fprintf(fDat, "clrmamepro (\n");
		fprintf(fDat, "\tname \"ACE\"\n");
		fprintf(fDat, "\tdescription \"ACE %s\"\n", cVersion);
		fprintf(fDat, "\tcategory \"Multiple arcade machine emulator\"\n");
		fprintf(fDat, "\tversion \"%s\"\n", cVersion);
		fprintf(fDat, "\tauthor \"friol\"\n");
		fprintf(fDat, "\tforcezipping zip\n");
		fprintf(fDat, ")\n\n");
	}
	else
	{
		fprintf(fDat, "[CREDITS]\n");
		fprintf(fDat, "Author=friol\n");
		fprintf(fDat, "Version=%s\n", cVersion);
		fprintf(fDat, "Comment=Multiple arcade machine emulator\n");
		fprintf(fDat, "[DAT]\n");
		fprintf(fDat, "version=2.00\n");
		fprintf(fDat, "[EMULATOR]\n");
		fprintf(fDat, "refname=ACE\n");
		fprintf(fDat, "version=ACE %s\n", cVersion);
		fprintf(fDat, "[GAMES]\n");
	}

	i=0;
	while (romsetList[i].name[0])
	{
		nNumRoms=romsetList[i].ncoderoms+
			romsetList[i].ngfxroms+
			romsetList[i].nsndcoderoms+
			romsetList[i].nsndsampleroms;

		strcpy(cParentName, romsetList[i].name);
		strcpy(cParentDescr, romsetList[i].descr);
		for (j=0; j<nNumRoms; j++)
		{
			if (strcmp(romsetList[i].name, romsetList[i].romlist[j].romset))
				strcpy(cParentName, romsetList[i].romlist[j].romset);
		}

		nFoundParent=0;
		if (strcmp(romsetList[i].name, cParentName))
		{
			j=0;
			while (romsetList[j].name[0])
			{
				if (!strcmp(romsetList[j].name, cParentName))
				{
					strcpy(cParentDescr, romsetList[j].descr);
					nFoundParent++;
				}
				j++;
			}
			if (!nFoundParent)
			{
				if (nDatType==0)
					fprintf(fDat, "; Unfortunately %s is not defined (needed for CMPro merging)\n\n",
						cParentName);
				strcpy(cParentName, romsetList[i].name);
			}
		}
		else
			strcpy(cParentDescr, romsetList[i].descr);

		if (nDatType==0)
		{
			fprintf(fDat, "game (\n");
			fprintf(fDat, "\tname %s\n", romsetList[i].name);
			fprintf(fDat, "\tdescription \"%s\"\n", romsetList[i].descr);
		}

		if (nFoundParent && nDatType==0)
		{
			fprintf(fDat, "\tcloneof %s\n", cParentName);
			fprintf(fDat, "\tromof %s\n", cParentName);
		}

		for (j=0; j<nNumRoms; j++)
		{
			if (nDatType==0)
			{
				fprintf(fDat, "\trom ( name %s ", romsetList[i].romlist[j].name);
				if (nFoundParent && strcmp(romsetList[i].name, romsetList[i].romlist[j].romset))
					fprintf(fDat, "merge %s ", romsetList[i].romlist[j].name);
				fprintf(fDat, "crc %08lx size %d )\n", 0, romsetList[i].romlist[j].size);
			}
			else
			{
				fprintf(fDat, "%s%s%s%s%s%08lx%d", cParentName, cParentDescr,
					romsetList[i].name, romsetList[i].descr, romsetList[i].romlist[j].name,
					0, romsetList[i].romlist[j].size);
				if (nFoundParent && strcmp(romsetList[i].name, cParentName))
				{
					fprintf(fDat, "%s", cParentName);
				
					if (strcmp(romsetList[i].name, romsetList[i].romlist[j].romset))
						fprintf(fDat, "%s\n", romsetList[i].romlist[j].name);
					else
						fprintf(fDat, "\n");
				}
				else
					fprintf(fDat, "\n");
			}
		}

		if (nDatType==0)
			fprintf(fDat, ")\n\n");

	i++;
	}

	fclose(fDat);

	return nRet;
};
