
/*

  selwindow component

*/


#include "selwindow.h"

extern tRomSet romsetList[];
extern tGui* gui;


#define clamp(x) (x<0)?0:(x>255)?255:x

//

tSelwindow::tSelwindow(int col,int fontcol,int gxs,int gys)
{
	ndisplay=15;
	ngames=0;
	topgame=0;
	fontcolor=fontcol;
	color=col;
	guiXsize=gxs;
	guiYsize=gys;
	active=0;
	selected=-1;
	clicked=0;
	mouseover=0;
	suphl=0;
	sdwhl=0;

	// at start, count number of supported games
	while (strlen(romsetList[ngames].name)!=0)
	{
		ngames++;
	}
}

void tSelwindow::update(guiInput* gi)
{
	int winxpos=110;
	int mxp;
	int myp;
	int posdiv;

	if ( (gui->guiinfo.videomode==1) || (gui->guiinfo.videomode==2) )
	{
		mxp=gi->mouseXpos/2;
		myp=gi->mouseYpos/2;
		posdiv=10;

		if (gui->orientation==VIDEO_ROT90)
		{
			myp+=48;
		}
	}
	else if (gui->guiinfo.videomode==0)
	{
		mxp=gi->mouseXpos;
		myp=gi->mouseYpos;
		posdiv=10;

		if (gui->orientation==VIDEO_ROT90)
		{
			mxp-=200;
		}
	}
	else if ( (gui->guiinfo.videomode==3) || (gui->guiinfo.videomode==4) )
	{
		mxp=gi->mouseXpos;
		myp=gi->mouseYpos;
		posdiv=9;
	}


	int poshighlight=1;
	selected=-1;

	if ( (mxp>(guiXsize/2-winxpos)) && (mxp<(guiXsize/2+winxpos-17)) && 
		 (myp>(guiYsize/2-70)) && (myp<(guiYsize/2+85)) )
	{
		mouseover=1;
		poshighlight=(myp-(guiYsize/2-70))/posdiv;
		selected=poshighlight;

		if ( (poshighlight<0) )
		{
			selected=-1;
		}
	}
	else
	{
		selected=-1;
		mouseover=0;
	}

	// highlight scrollbars?
	if ( (mxp>(guiXsize/2+winxpos-18)) && (mxp<(guiXsize/2+winxpos+14-22)) && 
  			  (myp>(guiYsize/2-72)) && (myp<(guiYsize/2-60)) )
	{
		suphl=1;
	}
	else suphl=0;

	// lower
	if ( (mxp>(guiXsize/2+winxpos-18)) && (mxp<(guiXsize/2+winxpos+14-22)) && 
  			  (myp>(guiYsize/2+59)) && (myp<(guiYsize/2+70)) )
	{
		sdwhl=1;
	}
	else sdwhl=0;

	// button pressed?
	if (gi->mousebutton1==1)
	{
		// game selected
		if ( (mxp>(guiXsize/2-winxpos)) && (mxp<(guiXsize/2+winxpos-17)) && 
			 (myp>(guiYsize/2-70)) && (myp<(guiYsize/2+85)) )
		{
			gi->mousebutton1=0;
			clicked=1;
			selected+=topgame;
		}
		// windowbox?
		else if ( (mxp>(guiXsize/2+winxpos-14)) && (mxp<(guiXsize/2+winxpos-6)) && 
			 (myp>(guiYsize/2-86)) && (myp<(guiYsize/2-76)) )
		{
			active=0;
			gi->mousebutton1=0;
		}
		// scrollboxes
		// upper
		else if ( (mxp>(guiXsize/2+winxpos-18)) && (mxp<(guiXsize/2+winxpos+14-22)) && 
  			      (myp>(guiYsize/2-72)) && (myp<(guiYsize/2-60)) )
		{
			if (topgame>0)
			{
				topgame--;
			}
			gi->mousebutton1=0;
		}
		// lower
		else if ( (mxp>(guiXsize/2+winxpos-18)) && (mxp<(guiXsize/2+winxpos+14-22)) && 
  			      (myp>(guiYsize/2+59)) && (myp<(guiYsize/2+70)) )
		{
			if (topgame<(ngames-ndisplay))
			{
				topgame++;
			}
			gi->mousebutton1=0;
		}
	}
}

void tSelwindow::drawRect(int x1,int y1,int x2,int y2,int col,unsigned long int* vbuf)
{
	for (int r=y1;r<y2;r++)
	{
		for (int c=x1;c<x2;c++)
		{
			vbuf[r*guiXsize+c]=col;
		}
	}

}

void tSelwindow::drawBox(int x1,int y1,int x2,int y2,int col,unsigned long int* vbuf)
{
	// upper and lower lines
	for (int x=x1;x<=x2;x++)
	{
		vbuf[y1*guiXsize+x]=col;
		vbuf[y2*guiXsize+x]=col;
	}

	// left and right lines
	for (int y=y1;y<y2;y++)
	{
		vbuf[y*guiXsize+x1]=col;
		vbuf[y*guiXsize+x2]=col;
	}
}

void tSelwindow::drawBlendRect(int x1,int y1,int x2,int y2,int col,unsigned long int* vbuf)
{
	int ar,ag,ab,r1,g1,b1,r2,g2,b2,rf,gf,bf;
	unsigned long int* pvbuf=&vbuf[y1*guiXsize+x1];

	r1=col&0xff; g1=(col>>8)&0xff; b1=(col>>16)&0xff;
	r2=clamp(r1+0x20); g2=clamp(g1+0x20); b2=clamp(b1+0x20);

	for (int r=y1;r<y2;r++)
	{
		for (int c=x1;c<x2;c++)
		{
			ar=(*pvbuf)&0xff; ag=((*pvbuf)>>8)&0xff; ab=((*pvbuf)>>16)&0xff;
			rf=clamp((ar+r1)/2); gf=clamp((ag+g1)/2); bf=clamp((ab+b1)/2);
			*pvbuf=rf|(gf<<8)|(bf<<16);
			pvbuf++;
		}
		pvbuf+=(guiXsize-(x2-x1));
	}
}

void tSelwindow::draw(unsigned long int* vbuf,tFont* f8x8,guiInput* gi)
{
	int winxpos=110;

	// window back
	drawBlendRect(guiXsize/2-winxpos,guiYsize/2-70,
		     guiXsize/2+winxpos-18,guiYsize/2+85,
			 color,vbuf);

	// box around
	if (!mouseover)
	{
		drawBox(guiXsize/2-winxpos,guiYsize/2-70,
				 guiXsize/2+winxpos-18,guiYsize/2+85,
				 0x202050,vbuf);
		drawBox(guiXsize/2-winxpos+1,guiYsize/2-70,
				 guiXsize/2+winxpos-1-18,guiYsize/2+84,
				 0x303060,vbuf);
	}
	else
	{
		drawBox(guiXsize/2-winxpos,guiYsize/2-70,
				 guiXsize/2+winxpos-18,guiYsize/2+85,
				 0x303060,vbuf);
		drawBox(guiXsize/2-winxpos+1,guiYsize/2-70,
				 guiXsize/2+winxpos-1-18,guiYsize/2+84,
				 0x404070,vbuf);
	}

	// upper box
	drawBlendRect(guiXsize/2-winxpos,guiYsize/2-85,
		     guiXsize/2+winxpos+14-18,guiYsize/2-71,
			 0x454575,vbuf);

	drawBox(guiXsize/2-winxpos,guiYsize/2-85,
		     guiXsize/2+winxpos+14-18,guiYsize/2-71,
			 0x252555,vbuf);

	// windowbox
	drawBox(guiXsize/2+winxpos-12+14-18,guiYsize/2-81,
		     guiXsize/2+winxpos-4+14-18,guiYsize/2-75,
			 0x505080,vbuf);

	// right scroller
	drawBlendRect(guiXsize/2+winxpos+2-18,guiYsize/2-70,
		     guiXsize/2+winxpos+14-18,guiYsize/2+85,
			 color,vbuf);
	drawBox(guiXsize/2+winxpos+1-18,guiYsize/2-70,
		     guiXsize/2+winxpos+14-18,guiYsize/2+85,
			 color,vbuf);

	// scrollboxes
	if (!suphl)
	{
		drawBox(guiXsize/2+winxpos+1-16,guiYsize/2-68,
				 guiXsize/2+winxpos+14-20,guiYsize/2-56,
				 color,vbuf);
	}
	else
	{
		drawBox(guiXsize/2+winxpos+1-16,guiYsize/2-68,
				 guiXsize/2+winxpos+14-20,guiYsize/2-56,
				 color,vbuf);
		drawBox(guiXsize/2+winxpos+1-15,guiYsize/2-67,
				 guiXsize/2+winxpos+14-21,guiYsize/2-57,
				 0x404070,vbuf);
	}

	if (!sdwhl)
	{
		drawBox(guiXsize/2+winxpos+1-16,guiYsize/2+72,
				 guiXsize/2+winxpos+14-20,guiYsize/2+83,
				 color,vbuf);
	}
	else
	{
		drawBox(guiXsize/2+winxpos+1-16,guiYsize/2+72,
				 guiXsize/2+winxpos+14-20,guiYsize/2+83,
				 color,vbuf);
		drawBox(guiXsize/2+winxpos+1-15,guiYsize/2+73,
				 guiXsize/2+winxpos+14-21,guiYsize/2+82,
				 0x404070,vbuf);
	}

	// scrollpos
	int sheight=(guiYsize/2+72)-(guiYsize/2-56);
	int spos;
	if (topgame==(ngames-ndisplay))
	{
		spos=((guiYsize/2-56)+(sheight*topgame)/(ngames-ndisplay))-10;
	}
	else
	{
		spos=(guiYsize/2-56)+(sheight*topgame)/(ngames-ndisplay);
	}

	drawRect(guiXsize/2+winxpos+1-15,spos,
		     guiXsize/2+winxpos+14-20,spos+10,
			 color,vbuf);
	drawBox(guiXsize/2+winxpos+1-16,spos,
		     guiXsize/2+winxpos+14-20,spos+10,
			 0x404070,vbuf);


	// window title
	f8x8->drawString("Select rom",fontcolor,
					 guiXsize/2-winxpos+5,(guiYsize/2-81),
					 guiXsize,guiYsize,vbuf);

	// draw rom names & highlight
	
	int pos=topgame;
	int j=0;
	
	while (j<ndisplay)
	{
		if (romsetList[pos+j].name[0]!='\0')
		{
			if ((mouseover) && (j==selected))
			{
				drawBox(guiXsize/2-winxpos+2,guiYsize/2-67+j*10,
						 guiXsize/2+winxpos-2-18,guiYsize/2-56+j*10,
						 0x303060,vbuf);
				drawRect(guiXsize/2-winxpos+2,guiYsize/2-66+j*10,
						 guiXsize/2+winxpos-2-18,guiYsize/2-56+j*10,
						 fontcolor,vbuf);
			}

			f8x8->drawString(romsetList[pos+j].descr,fontcolor,
								guiXsize/2-winxpos+5,(guiYsize/2-65)+j*10,
								guiXsize,guiYsize,vbuf);
		}
		else
		{
			return ;
		}

		j++;
	}
}
