
/*

	where the fun starts (again)
	7/7/2001

*/


#include "cps2cpucore.h"
#include "cps2charset.h"

#include "qsound/qsound.h"
#include "eeprom/eeprom.h"

//#define PROFILE

 
extern tGui* gui;
extern int do_ss; // do the screenshot
extern int goshift;
extern int multiply;

static unsigned short int in0;
static unsigned short int in1;
static unsigned short int in2;
static int objram_bank;
static unsigned long int fac1,fac2,multlo,multhi;

static  unsigned char* rom68k;
static 	unsigned char* crypt;
static 	unsigned char* cps1ram;
static 	unsigned char* output_port;
static 	unsigned char* gfxram;
static 	unsigned char* objram1;
static 	unsigned char* objram2;
static 	unsigned char objectoutput[0x0c];

static int qsound_data=0;
static unsigned char* z80prg=0;
static unsigned char* qsoundram1=0;

int r8ff=0;
int r16ff=0;
int r32ff=0;
int r8gfx=0;
int r16gfx=0;
int r32gfx=0;

// z80 read/write functions

static unsigned char z80rd(unsigned long int A,struct MemoryReadByte* mwb)
{
	if ( (A>=0xc000) && (A<=0xcfff) )
	{
		return qsoundram1[A-0xc000];
	}
	else if (A==0xd007)
	{
		return 0x80;
	}

	return 0;
}


static void z80wr(unsigned long int A,unsigned char V,struct MemoryWriteByte* mwb)
{
	if ( (A>=0xc000) && (A<0xd000) )
	{
		qsoundram1[A-0xc000]=V;
	}
	else if (A==0xd000)
	{
		// qsound_data_h_w
		qsound_data=(qsound_data&0xff)|(V<<8);
	}
	else if (A==0xd001)
	{
		// qsound_data_l_w
		qsound_data=(qsound_data&0xff00)|V;
	}
	else if (A==0xd002)
	{
		// qsound_cmd_w
		qsound_set_command(V, qsound_data);
	}
	else if (A==0xd003)
	{
		// qsound_banksw_w
		int bankaddress=0x10000+((V&0x0f)*0x4000);
		memcpy(z80prg+0x8000,z80prg+bankaddress,0x4000);
	}
}

// z80 handlers

static struct z80PortRead z80ReadPorts[] =
{
	{-1,-1,0}
};

static struct z80PortWrite z80WritePorts[] =
{
	{-1,-1,0}
};

static struct MemoryReadByte z80readmem[] =
{
	{0xc000,0xefff,z80rd,0},
	{-1,-1,0,0}
};
  
static struct MemoryWriteByte z80writemem[] =
{
	{0x0000,0xefff,z80wr,0},
	{-1,-1,0,0}
};


// eepro-t - thanks again to mame team

static struct EEPROM_interface cps2_eeprom_interface =
{
	6,		/* address bits */
	16,		/* data bits */
	"0110",	/*  read command */
	"0101",	/* write command */
	"0111"	/* erase command */
};

// cps2 decrypt

void cps2cpucore::cps2decrypt()
{
	int i;

	unsigned char* temp=new unsigned char [0x400000];

	memcpy(temp,rom68k,0x400000);

	for (i=0;i<0x400000;i++)
	{
		rom68k[i]=rom68k[i]^crypt[i];
	}

	memcpy(crypt,temp,0x400000);

	delete [] temp;
}

// a68k

static __inline int irqcall(int i)
{
	return -1;
}
 
int cps2cpucore::a68kReset()
{
	memset(&M68000_regs,0,sizeof(M68000_regs));

	unsigned int sp,pc;

	sp=READ32(rom68k,0,0);
	pc=READ32(rom68k,4,0);

	M68000_regs.pc=pc;
	M68000_regs.a[7]=sp; 
	M68000_regs.srh=0x27;

	M68000_regs.IrqCallback=irqcall;

    M68000_RESET();

	return 0;
}

static __inline void changepc(int pc)
{
}

// cpu init

cps2cpucore::cps2cpucore(tRomSpace* roms)
{
	layer_enabled[0]=1;
	layer_enabled[1]=1;
	layer_enabled[2]=1;
	layer_enabled[3]=1;
	objram_bank=0;
	in0=0xffff;
	in1=0xffff;
	in2=0xfffe;

	rom68k=new unsigned char [0x400000];
	crypt=new unsigned char [0x400000];
	cps1ram=new unsigned char [0x10000];
	qsoundram1=new unsigned char [0x1000];
	objram1=new unsigned char [0x2000];
	objram2=new unsigned char [0x2000];
	output_port=new unsigned char [0x100];
	gfxram=new unsigned char [0x30000];

	z80prg=new unsigned char [0x80000];
	qsoundrom=new signed char [0x400000];

	// init memory areas

	memset(rom68k,0,0x400000);
	memset(crypt,0,0x400000);

	memcpy(rom68k,roms->romCPU1,0x400000);
	memcpy(crypt,roms->romCPU1+0x400000,0x400000);

	// decrypt cps2 code
	cps2decrypt();

	memset(objram1,0,0x2000);
	memset(objram2,0,0x2000);
	memset(objectoutput,0,0x0c);
	memset(gfxram,0,0x30000);
	memset(output_port,0,0x100);
	memset(cps1ram,0,0x10000);
	memset(qsoundram1,0,0x1000);

	memset(z80prg,0,0x80000);
	memcpy(z80prg,roms->romCPU2,0x8000);
	memcpy(z80prg+0x10000,roms->romCPU2+0x8000,0x18000);
	memcpy(z80prg+0x28000,roms->romCPU2+0x20000,0x20000);
	memcpy(z80prg+0x8000,roms->romCPU2+0x10000,0x4000);

	memcpy(qsoundrom,roms->romqsound,0x400000);

	// set up values

	strcpy(romname,roms->romname);
	multlo=roms->multlo;
	multhi=roms->multhi;
	fac1=roms->fac1;
	fac2=roms->fac2;
	kludge=roms->kludge;
	layercontrol=roms->layercontrol;
	charbase=roms->charbase;
	tile16base=roms->tile16base;
	tile32base=roms->tile32base;
	charpad=roms->charpad;
	tile16pad=roms->tile16pad;
	tile32pad=roms->tile32pad;

	// init 68000 cpu

 	a68k_memory_intf.opcode_xor = 0x400000;
 	a68k_memory_intf.read8 = cps2_m68kr8;
 	a68k_memory_intf.read16 = cps2_m68kr16;
 	a68k_memory_intf.read32 = cps2_m68kr32;
 	a68k_memory_intf.write8 = cps2_m68kw8;
 	a68k_memory_intf.write16 = cps2_m68kw16;
 	a68k_memory_intf.write32 = cps2_m68kw32;
 	a68k_memory_intf.changepc = changepc;

 	a68k_memory_intf.read8pc = cps2_m68krpc8;
 	a68k_memory_intf.read16pc = cps2_m68krpc16;
 	a68k_memory_intf.read32pc = cps2_m68krpc32;
 	a68k_memory_intf.read16d = cps2_m68kri16;
 	a68k_memory_intf.read32d = cps2_m68kri32;

	OP_ROM=rom68k;
	OP_RAM=rom68k;
	
	a68kReset();

	// init eeprom

	EEPROM_init(&cps2_eeprom_interface);

	// init z80

	if (!gui->z80init)
	{
		mz80init();
	}

	ctx1.z80Base=z80prg;
	ctx1.z80IoRead=z80ReadPorts;
	ctx1.z80IoWrite=z80WritePorts;
	ctx1.z80MemRead=z80readmem;
	ctx1.z80MemWrite=z80writemem;

	mz80SetContext(&ctx1);
	mz80reset();
	mz80GetContext(&ctx1);

	// init qsound

	sndbufsize=gui->guiinfo.soundfreq/60;

	soundbuf[0]=new signed short int [sndbufsize];
	soundbuf[1]=new signed short int [sndbufsize];
	realsoundbuf=new signed short int [sndbufsize*2];

	QSound_interface qs;
	qs.clock=3800000;
	qs.samplerom=qsoundrom;
	qs.mixing_level[0]=100;
	qs.mixing_level[1]=100;
	qs.freq=gui->guiinfo.soundfreq;

	qsound_sh_start(&qs);

	gui->z80init=1;
}

cps2cpucore::~cps2cpucore()
{
	delete [] rom68k;
	delete [] crypt;

	delete [] cps1ram;
	delete [] qsoundram1;
	delete [] output_port;
	delete [] gfxram;
	delete [] objram1;
	delete [] objram2;
	delete [] z80prg;
	delete [] qsoundrom;

	delete [] soundbuf[0];
	delete [] soundbuf[1];
	delete [] realsoundbuf;

#ifdef PROFILE
	char profile[1024];
	sprintf(profile,"gfx [%d] [%d] [%d] ff [%d] [%d] [%d]",
		    r8gfx,r16gfx,r32gfx,r8ff,r16ff,r32ff);
	MessageBox(0,profile,"info",MB_OK);
#endif
}


void cps2cpucore::emulate(int snd)
{
	unsigned long int dwres;

	if (!snd)
	{
		qsoundram1[0xfff] = 0x77;		
		m68k_ICount=196666;
		M68000_RUN();
		M68000_regs.irq=2;
	}
	else
	{
		for (int i=0;i<4;i++)
		{
			m68k_ICount=196666/4;
			M68000_RUN();

			// z80 - 8 mhz

			mz80SetContext(&ctx1);
			dwres=mz80exec(133333/4);	
			if (dwres!=0x80000000)
			{
				MessageBox(NULL,"z80 bad op","error",MB_OK);
			}
			mz80int(0x38);
			mz80GetContext(&ctx1);
		}

		M68000_regs.irq=2;

		qsound_update(0,soundbuf,sndbufsize);

		signed short int* pb0=soundbuf[0];
		signed short int* pb1=soundbuf[1];
		signed short int* rsb=realsoundbuf;

		for (i=0;i<sndbufsize;i++)
		{
			*rsb=*pb0; rsb++; pb0++;
			*rsb=*pb1; rsb++; pb1++;
		}

		feedBuffer(realsoundbuf,sndbufsize*2);
	}
}

void cps2cpucore::update_controls()
{
	if (gui->ginput.coin1==1)
	{
		in2=in2&(~0x1000);
	}
	else
	{
		in2=in2|0x1000;
	}

	if (gui->ginput.start1==1)
	{
		in2=in2&(~0x100);
	}
	else
	{
		in2=in2|0x100;
	}

	if (gui->ginput.p1left==1)
	{
		in0=in0&(~0x02);
	}
	else
	{
		in0=in0|0x02;
	}

	if (gui->ginput.p1right==1)
	{
		in0=in0&(~0x01);
	}
	else
	{
		in0=in0|0x01;
	}

	if (gui->ginput.p1up==1)
	{
		in0=in0&(~0x08);
	}
	else
	{
		in0=in0|0x08;
	}

	if (gui->ginput.p1down==1)
	{
		in0=in0&(~0x04);
	}
	else
	{
		in0=in0|0x04;
	}

	if (gui->ginput.p1button[0]==1)
	{
		in0=in0&(~0x10);
	}
	else
	{
		in0=in0|0x10;
	}

	if (gui->ginput.p1button[1]==1)
	{
		in0=in0&(~0x20);
	}
	else
	{
		in0=in0|0x20;
	}

	if (gui->ginput.p1button[2]==1)
	{
		in0=in0&(~0x40);
	}
	else
	{
		in0=in0|0x40;
	}

	if (gui->ginput.p1button[3]==1)
	{
		in1=in1&(~0x1);
	}
	else
	{
		in1=in1|0x1;
	}

	if (gui->ginput.p1button[4]==1)
	{
		in1=in1&(~0x2);
	}
	else
	{
		in1=in1|0x2;
	}

	if (gui->ginput.p1button[5]==1)
	{
		in1=in1&(~0x4);
	}
	else
	{
		in1=in1|0x4;
	}
}

int cps1_multiply(unsigned long int offset)
{
	// fac1,fac2,multlo,multhi
	// 0x4e,0x4c,0x4a,0x48

	if (offset == multlo)	
	{
		unsigned short int* pop4e=(unsigned short int*)&output_port[fac1];
		unsigned short int* pop4c=(unsigned short int*)&output_port[fac2];

		return ((*pop4e)*(*pop4c))&0xffff;
	}

	if (offset == multhi)	
	{
		unsigned short int* pop4e=(unsigned short int*)&output_port[fac1];
		unsigned short int* pop4c=(unsigned short int*)&output_port[fac2];

		return ((*pop4e)*(*pop4c))>>16;
	}

	return 0;
}

//
// read-write handlers
//

// pc-relativee stuph

unsigned short int cps2_m68kri16(int address)
{
	if (address<=0x3fffff) 
	{
		return READ16(rom68k,address,0);
	}

	return 0;
}

unsigned long int cps2_m68kri32(int address)
{
	return ((cps2_m68kri16(address) << 16) | cps2_m68kri16((address)+2));
}

unsigned char cps2_m68krpc8(int address)
{
	if (address<=0x3fffff)
	{
		return ((cps2_m68kri16(address&~1)>>(8*(1-(address & 1))))&0xff);
	}

	return cps2_m68kr8(address);
}

unsigned short int cps2_m68krpc16(int address)
{
	if (address<=0x3fffff)
	{
		return READ16(rom68k,address,0);
	}

	return cps2_m68kr16(address);
}

unsigned long int cps2_m68krpc32(int address)
{
	if (address<=0x3fffff)
	{
		return cps2_m68kri32(address);
	}

	return cps2_m68kr32(address);
}

unsigned char cps2_m68kr8(int address)
{
	address&=0xffffff;

	if (address<=0x3fffff)
	{
		return READ8(crypt,address,0);
	}
	else if ( (address>=0xff0000) && (address<=0xffffff) )
	{
		return READ8(cps1ram,address,0xff0000);
	}
	else if ( (address>=0x618000) && (address<=0x619fff) )
	{
		return (qsoundram1[(address-0x618000)/2]);
	}
	else if ( (address>=0x400000) && (address<=0x40000b) )
	{
		return READ8(objectoutput,address,0x400000);
	}
/*	else if ( (address>=0x660000) && (address<=0x664001) )
	{
		return READ8(extraram,address,0x660000);
	}
*/	else if ( (address>=0x900000) && (address<=0x92ffff) )
	{
		return READ8(gfxram,address,0x900000);
	}
	else if (address==0x804001)
	{
		return in0&0xff;
	}
	else if (address==0x804000)
	{
		return ((in0>>8)&0xff);
	}
	else if ( (address>=0x804010) && (address<=0x804011) )
	{
		return in1;
	}
	else if (address==0x804021) 
	{
		unsigned short int res=((in2&0xfffe)| EEPROM_read_bit());
		return (res&0xff);
	}
	else if (address==0x804020) 
	{
		return (in2>>8)&0xff;
	}
	else if (address==0x804030)
	{
	    return 0xe0;
	}
	else if (address==0x804031)
	{
	    return 0x21;
	}
	else if ( (address>=0x8040b0) && (address<=0x8040b3) )
	{
		return 0xff;
	}
	else if ( (address>=0x708000) && (address<=0x70ffff) )
	{
		if (objram_bank&1)
		{
			return objram1[address&0x1fff];
		}
		else
		{
			return objram2[address&0x1fff];
		}
	}

	return 0;
}

unsigned short int cps2_m68kr16(int address)
{
	address&=0xffffff;

	if (address<=0x3fffff)
	{
		return READ16(crypt,address,0);
	}
	else if ( (address>=0xff0000) && (address<=0xffffff) )
	{
		return READ16(cps1ram,address,0xff0000);
	}
	else if ( (address>=0x900000) && (address<=0x92ffff) )
	{
		return READ16(gfxram,address,0x900000);
	}
	else if ( (address>=0x618000) && (address<=0x619fff) )
	{
		return (qsoundram1[(address-0x618000)/2]|0xff00);
	}
	else if ( (address>=0x400000) && (address<=0x40000b) )
	{
		return READ16(objectoutput,address,0x400000);
	}
/*	else if ( (address>=0x660000) && (address<=0x664001) )
	{
		return READ16(extraram,address,0x660000);
	}
*/	else if ( (address>=0x804000) && (address<=0x804001) )
	{
		return in0;
	}
	else if ( (address>=0x804010) && (address<=0x804011) )
	{
		return in1;
	}
	else if ( (address>=0x804020) && (address<=0x804021) )
	{
		return ((in2&0xfffe)| EEPROM_read_bit());
	}
	else if ( (address>=0x804030) && (address<=0x804031) )
	{
	    return 0xe021;
	}
	else if ( (address>=0x8040b0) && (address<=0x8040b3) )
	{
		return 0xffff;
	}
	else if ( (address>=0x708000) && (address<=0x70ffff) )
	{
		if (objram_bank&1)
		{
			return READ16(objram1,address&0x1fff,0);
		}
		else
		{
			return READ16(objram2,address&0x1fff,0);
		}
	}
	else if (address==multlo)
	{
		return cps1_multiply(multlo);
	}
	else if (address==multhi)
	{
		return cps1_multiply(multhi);
	}

	return 0;
}

unsigned long int cps2_m68kr32(int address)
{
	address&=0xffffff;

	if (address<=0x3fffff)
	{
		return READ32(crypt,address,0);
	}
	else if ( (address>=0xff0000) && (address<=0xffffff) )
	{
		return READ32(cps1ram,address,0xff0000);
	}
/*	else if ( (address>=0x660000) && (address<=0x664001) )
	{
		return READ32(extraram,address,0x660000);
	}
*/	else if ( (address>=0x900000) && (address<=0x92ffff) )
	{
		return READ32(gfxram,address,0x900000);
	}
	else if ( (address>=0x400000) && (address<=0x40000b) )
	{
		return READ32(objectoutput,address,0x400000);
	}
	else if ( (address>=0x804030) && (address<=0x804031) )
	{
	    return 0xe021;
	}
	else if ( (address>=0x8040b0) && (address<=0x8040b3) )
	{
		return 0xffff;
	}
	else if ( (address>=0x708000) && (address<=0x70ffff) )
	{
		if (objram_bank&1)
		{
			return READ32(objram1,address&0x1fff,0);
		}
		else
		{
			return READ32(objram2,address&0x1fff,0);
		}
	}

	return 0;
}

void cps2_m68kw8(int address, unsigned char value)
{
	address&=0xffffff;

	if (address>=0xff0000)
	{
		WRITE8(cps1ram,address,0xff0000,value);
		return ;
	}
	else if ( (address>=0x900000) && (address<=0x92ffff) )
	{
		WRITE8(gfxram,address,0x900000,value);
		return ;
	}
	else if ( (address>=0x618000) && (address<=0x619fff) )
	{
		qsoundram1[(address-0x618000)/2]=value&0xff;
		return ;
	}
	else if ( (address>=0x400000) && (address<=0x40000b) )
	{
		WRITE8(objectoutput,address,0x400000,value);
		return ;
	}
/*	else if ( (address>=0x660000) && (address<=0x664001) )
	{
		WRITE8(extraram,address,0x660000,value);
		return ;
	}
*/	else if ( (address>=0x800100) && (address<=0x8001ff) )
	{
		WRITE8(output_port,address,0x800100,value);
		return ;
	} 
	else if (address==0x804040)
	{
		int v2=value<<8;
        EEPROM_write_bit(v2 & 0x1000);
        EEPROM_set_clock_line((v2 & 0x2000) ? ASSERT_LINE : CLEAR_LINE);
        EEPROM_set_cs_line((v2 & 0x4000) ? CLEAR_LINE : ASSERT_LINE);
		return ;
	}
	else if ( (address>=0x804100) && (address<=0x8041ff) )
	{
		WRITE8(output_port,address,0x804100,value);
		return ;
	}
	else if ( (address>=0x708000) && (address<=0x70ffff) )
	{
		if (objram_bank&1)
		{
			objram1[address&0x1fff]=value;
			return ;
		}
		else
		{
			objram2[address&0x1fff]=value;
			return ;
		}
	}
	else if ( (address>=0x8040e0) && (address<=0x8040e1) )
	{
		objram_bank=value&1;
		return;
	}

	address=address;
}

void cps2_m68kw16(int address, unsigned short int value)
{
	address&=0xffffff;

	if (address>=0xff0000)
	{
		WRITE16(cps1ram,address,0xff0000,value);
		return ;
	}
	else if ( (address>=0x900000) && (address<=0x92ffff) )
	{
		WRITE16(gfxram,address,0x900000,value);
		return ;
	}
	else if ( (address>=0x618000) && (address<=0x619fff) )
	{
		qsoundram1[(address-0x618000)/2]=(value>>8)&0xff;
		return ;
	}
	else if ( (address>=0x800100) && (address<=0x8001ff) )
	{
		WRITE16(output_port,address,0x800100,value);
		return ;
	}
	else if (address==0x804040)
	{
        EEPROM_write_bit(value & 0x1000);
        EEPROM_set_clock_line((value & 0x2000) ? ASSERT_LINE : CLEAR_LINE);
        EEPROM_set_cs_line((value & 0x4000) ? CLEAR_LINE : ASSERT_LINE);
		return ;
	}
	else if ( (address>=0x804100) && (address<=0x8041ff) )
	{
		WRITE16(output_port,address,0x804100,value);
		return ;
	}
	else if ( (address>=0x708000) && (address<=0x70ffff) )
	{
		if (objram_bank&1)
		{
			WRITE16(objram1,address&0x1fff,0,value);
			return ;
		}
		else
		{
			WRITE16(objram2,address&0x1fff,0,value);
			return ;
		}
	}
/*	else if ( (address>=0x660000) && (address<=0x664001) )
	{
		WRITE16(extraram,address,0x660000,value);
		return ;
	}
*/	else if ( (address>=0x8040e0) && (address<=0x8040e1) )
	{
		objram_bank=value&1;
		return;
	}
	else if ( (address>=0x400000) && (address<=0x40000b) )
	{
		WRITE16(objectoutput,address,0x400000,value);
		return ;
	}

	address=address;
}

void cps2_m68kw32(int address, unsigned long int value)
{
	address&=0xffffff;

	if (address>=0xff0000)
	{
		WRITE32(cps1ram,address,0xff0000,value);
		return ;
	}
	else if ( (address>=0x900000) && (address<=0x92ffff) )
	{
		WRITE32(gfxram,address,0x900000,value);
		return ;
	}
	else if ( (address>=0x400000) && (address<=0x40000b) )
	{
		WRITE32(objectoutput,address,0x400000,value);
		return ;
	}
/*	else if ( (address>=0x660000) && (address<=0x664001) )
	{
		WRITE32(extraram,address,0x660000,value);
		return ;
	}
*/	else if ( (address>=0x800100) && (address<=0x8001ff) )
	{
		WRITE32(output_port,address,0x800100,value);
		return ;
	}
	else if ( (address>=0x804100) && (address<=0x8041ff) )
	{
		WRITE32(output_port,address,0x804100,value);
		return ;
	}
	else if ( (address>=0x708000) && (address<=0x70ffff) )
	{
		if (objram_bank&1)
		{
			WRITE32(objram1,address&0x1fff,0,value);
			return ;
		}
		else
		{
			WRITE32(objram2,address&0x1fff,0,value);
			return ;
		}
	}
	else if (address==0x804040)
	{
        EEPROM_write_bit(value & 0x1000);
        EEPROM_set_clock_line((value & 0x2000) ? ASSERT_LINE : CLEAR_LINE);
        EEPROM_set_cs_line((value & 0x4000) ? CLEAR_LINE : ASSERT_LINE);
		return ;
	}
	else if ( (address>=0x8040e0) && (address<=0x8040e1) )
	{
		objram_bank=value&1;
		return;
	}

	address=address;
}

//
//
//

void cps2cpucore::build_palette(tCharset* chset)
{
	// get palette base

	unsigned short int* popp=(unsigned short int*)&output_port[0x0a];
	int base=*popp*256;
	base&= ~(0x2000-1);
	unsigned char* ppal=(unsigned char*)&gfxram[base&0x3ffff];

	int offset;

	for (offset = 0; offset < 32*32*8; offset++)
	{
		int palette = READ_WORD(&ppal[offset*2]);

		int red, green, blue, bright;

		bright= (palette>>12)&0x1f;
		if (bright) bright+=2;

		red   = ((palette>>8)&0x0f) * bright;
		green = ((palette>>4)&0x0f) * bright;
		blue  = (palette&0x0f) * bright;

		// store

		chset->palette[offset*4+2]=red;
		chset->palette[offset*4+1]=green;
		chset->palette[offset*4+0]=blue;
		chset->palette[offset*4+3]=0;
	}
}


/*

  scroll 1

*/

void cps2cpucore::drawScroll1(unsigned long int* video,tCharset* chset)
{
	// base of scroll1 is at output ports 0x02-0x03
	// scroll1 x and y are at 0x0c and 0x0e

	unsigned short int* popbs1=(unsigned short int*)&output_port[0x02];
	unsigned short int* pops1x=(unsigned short int*)&output_port[0x0c];
	unsigned short int* pops1y=(unsigned short int*)&output_port[0x0e];

	int x,y, offs, offsx, offsy, sx, sy, ytop;
	int code,realcode,attr,cl,ch;

	int scroll1x=(*pops1x)&0xffff;
	int scroll1y=(*pops1y)&0xffff;

	int base=*popbs1*256;
	base&= ~(0x4000-1);

	unsigned char* c_pgfx=(unsigned char*)&gfxram[base&0x3ffff];

	FILE* ss;
	if (do_ss==1)
	{
		ss=fopen("ss1.bin","wb");
	}

	// draw layer

	cps2charset* pchs=(cps2charset*)chset;

	int scrlxrough=(scroll1x>>3)+4;
	int scrlyrough=(scroll1y>>3);

	sx=-(scroll1x&0x07)-32;
	ytop=-(scroll1y&0x07)-16;

	for (x=0; x<0x35; x++)
	{
		 sy=ytop;
		 offsx=(scrlxrough+x)*0x80;
		 offsx&=0x1fff;

		 for (y=0; y<0x20; y++)
		 {
			int n=scrlyrough+y;
			offsy=( (n&0x1f)*4 | ((n&0x20)*0x100)) & 0x3fff;
			offs=offsy+offsx;
			offs &= 0x3fff;

			// read code and attrib
			
			code=READ_WORD(&c_pgfx[offs]);
			attr=READ_WORD(&c_pgfx[offs+2]);

			realcode=(code-charbase)&charpad;

			if (realcode!=0x20) 
			{
				pchs->printChar(video,realcode,attr&0x1f,sx,sy,attr&0x20,attr&0x40);
			}

			if (do_ss==1)
			{
				fwrite(&ch,1,1,ss); fwrite(&cl,1,1,ss);
				cl =code &0xff;	ch =(code >>8)&0xff;
			}

			sy+=8;
		 }
		 sx+=8;
	}

	if (do_ss==1)
	{
		fclose(ss);
	}
}

/*

  Scroll 2

*/

void cps2cpucore::drawScroll2(unsigned long int* video,tCharset* chset)
{
	// base of scroll2 is at output ports 0x04-0x05
	// scroll2 x and y are at 0x10 and 0x12

	unsigned short int* popbs2=(unsigned short int*)&output_port[0x04];
	unsigned short int* pops2x=(unsigned short int*)&output_port[0x10];
	unsigned short int* pops2y=(unsigned short int*)&output_port[0x12];

	int base=*popbs2*256;
	base&= ~(0x4000-1);

	unsigned char* c_pgfx=(unsigned char*)&gfxram[base&0x3ffff];

	int scroll2x=*pops2x+64;
	int scroll2y=*pops2y+64-16;

	int sx, sy;
	int nxoffset=(scroll2x&0x0f)+32;    
	int nyoffset=(scroll2y&0x0f);    
	int nx=(scroll2x>>4);	  
	int ny=(scroll2y>>4)-4;	

	FILE* ss;
	if (do_ss==1)
	{
		ss=fopen("ss2.bin","wb");
	}

	cps2charset* pchs=(cps2charset*)chset;

	for (sx=0; sx<0x32/2+4; sx++)
	{
		for (sy=0; sy<0x09*2+goshift; sy++)
		{
			int offsy, offsx, offs, colour, code,cl,ch,realcode;
			int n;
			n=ny+sy+2;
			offsy  = ((n&0x0f)*4 | ((n&0x30)*0x100))&0x3fff;
			offsx=((nx+sx)*0x040)&0xfff;
			offs=offsy+offsx;
			offs &= 0x3fff;

			code=  READ_WORD(&c_pgfx[offs]);
			colour=READ_WORD(&c_pgfx[offs+2]);

			realcode=(code-tile16base)&tile16pad;

			if (do_ss==1)
			{
				cl =code &0xff;	ch =(code >>8)&0xff;
				fwrite(&ch,1,1,ss); fwrite(&cl,1,1,ss);
			}

			pchs->printTile16(video,realcode,colour&0x1f,
							   (16*sx)-(nxoffset-32),
							   (16*sy)-nyoffset,
							   colour&0x20,colour&0x40);
		}
	}

	if (do_ss==1)
	{
		fclose(ss);
	}
}

void cps2cpucore::drawScroll2rs(unsigned long int* video,tCharset* chset)
{
	// base of scroll2 is at output ports 0x04-0x05
	// scroll2 x and y are at 0x10 and 0x12

	unsigned short int* popbs2=(unsigned short int*)&output_port[0x04];
	unsigned short int* pops2x=(unsigned short int*)&output_port[0x10];
	unsigned short int* pops2y=(unsigned short int*)&output_port[0x12];

	int base=*popbs2*256;
	base&= ~(0x4000-1);

	unsigned char* c_pgfx=(unsigned char*)&gfxram[base&0x3ffff];

	// we should get rowscroll ram base (0x08)
	// and rowscroll offset (0x20)

	unsigned short int* prowscroll=(unsigned short int*)&output_port[0x08];
	base=*prowscroll*256;
	base&=~(0x800-1);
	unsigned char* prs=(unsigned char*)&gfxram[base&0x3ffff];

	unsigned short int* prowscrolloffs=(unsigned short int*)&output_port[0x20];
	int rowscrolloffs=*prowscrolloffs;

	//

	int scroll2x=*pops2x+64;
	int scroll2y=*pops2y;

	int sx, sy;
	int nxoffset=(scroll2x&0x0f)+32;    
	int nyoffset=(scroll2y&0x0f);    
	int nx=(scroll2x>>4);	  
	int ny=(scroll2y>>4)-4;	

	//

	int scrly=-scroll2y;

	for (int i=0;i<256 ;i++)
	{
		chset->rowscroll[(i - scrly) & 0x3ff] = (( -(READ_WORD(&prs[(2*(i + rowscrolloffs)) & 0x7ff]))));
	}

	//

	FILE* ss;
	if (do_ss==1)
	{
		ss=fopen("ss2.bin","wb");
	}

	cps2charset* pchs=(cps2charset*)chset;

	for (sx=0x2a; sx>=0; sx--)
	{
		int n=ny;
		for (sy=0x12-1; sy>=0; sy--)
		{
			int realcode,ch,cl;
			int offsy, offsx, offs, colour, code;

			n=ny+sy+2;
			offsy  = ((n&0x0f)*4 | ((n&0x30)*0x100))&0x3fff;
			offsx=((nx+sx)*0x040)&0xfff;
			offs=offsy+offsx;
			offs &= 0x3fff;

			code=  READ_WORD(&c_pgfx[offs]);
			colour=READ_WORD(&c_pgfx[offs+2]);

			realcode=(code-tile16base)&tile16pad;

			if (do_ss==1)
			{
				cl =code &0xff;	ch =(code >>8)&0xff;
				fwrite(&ch,1,1,ss); fwrite(&cl,1,1,ss);
			}

			pchs->printTile16rs(video,realcode,colour&0x1f,
							   (16*sx)+32-nxoffset,
							   (16*sy)-nyoffset-48,
							   colour&0x20,colour&0x40,(-scrly+0x10)&0x3ff);
		}
	}

	if (do_ss==1)
	{
		fclose(ss);
	}
}


/*

  Scroll 3

*/

void cps2cpucore::drawScroll3(unsigned long int* video,tCharset* chset)
{
	// base of scroll3 is at output ports 0x06-0x07
	// scroll3 x and y are at 0x14 and 0x16

	unsigned short int* popbs3=(unsigned short int*)&output_port[0x06];
	unsigned short int* pops3x=(unsigned short int*)&output_port[0x14];
	unsigned short int* pops3y=(unsigned short int*)&output_port[0x16];

	int base=(*popbs3)*256;
	base&= ~(0x4000-1);

	unsigned char* c_pgfx=(unsigned char*)&gfxram[base&0x3ffff];

	int scroll3x=*pops3x;
	int scroll3y=*pops3y;

	int sx,sy;
	int nxoffset=scroll3x&0x1f;
	int nyoffset=scroll3y&0x1f;
	int nx=(scroll3x>>5)+1;
	int ny=(scroll3y>>5)-1;

	FILE* ss;
	if (do_ss==1)
	{
		ss=fopen("ss3.bin","wb");
	}

	cps2charset* pchs=(cps2charset*)chset;

	for (sx=1; sx<14; sx++)
	{
		for (sy=1; sy<10; sy++)
		{
			int offsy, offsx, offs, colour, code,realcode;
			int n;
			n=ny+sy;
			offsy  = ((n&0x07)*4 | ((n&0xf8)*0x0100))&0x3fff;
			offsx=((nx+sx)*0x020)&0x7ff;
			offs=offsy+offsx;
			offs &= 0x3fff;

			colour=READ_WORD(&c_pgfx[offs+2]);
			code=READ_WORD(&c_pgfx[offs]);

			if (do_ss==1)
			{
				int cl,ch;

				cl=code&0xff; 
				ch=(code>>8)&0xff;

				fwrite(&ch,1,1,ss); fwrite(&cl,1,1,ss);
			}

			realcode=(code-tile32base)&tile32pad;
			if (realcode!=0)
			{
				pchs->printTile32(video,realcode,colour&0x1f,
								   32*sx-nxoffset-32,
								   32*sy-nyoffset-64+16,
								   colour&0x20,colour&0x40);
			}
		}
	}

	if (do_ss==1)
	{
		fclose(ss);
	}
}

/*

  Spiritezz

*/

void cps2cpucore::cps2calc_lso()
{
	int offset=0;
	int found=0;

	unsigned char* c_pgfx;
	unsigned short int* popbss=(unsigned short int*)&output_port[0x00];
	int base=*popbss*256;
	base&= ~(0x800-1);

	// banks
	if (objram_bank&1)
	{
		c_pgfx=(unsigned char*)&objram1[base&0x1fff];
	}
	else
	{
		c_pgfx=(unsigned char*)&objram2[base&0x1fff];
	}

	while ( (offset < 0x2000) && (!found) )
	{
		int colour1=READ_WORD(&c_pgfx[offset+6]);
		int colour2=READ_WORD(&c_pgfx[offset+2]);

		if ( (colour1>=0xff00) || (colour2>=0x8000) )
		{
			cps1_lso=offset-8;
			found=1;
		}
		else
		{
			offset+=8;
		}
	}
	if (!found) cps1_lso=0x2000-8;
}

void cps2cpucore::drawSprites(unsigned long int* video,tCharset* chset,int minpri,int maxpri)
{
	if (minpri > maxpri) return;

	unsigned char* c_pgfx;
	unsigned short int* popbss=(unsigned short int*)&output_port[0x00];
	int base=*popbss*256;
	base&= ~(0x800-1);

	// banks
	if (objram_bank&1)
	{
		c_pgfx=(unsigned char*)&objram1[base&0x1fff];
	}
	else
	{
		c_pgfx=(unsigned char*)&objram2[base&0x1fff];
	}

	FILE* ss;
	if (do_ss==1)
	{
		ss=fopen("sss.bin","wb");
	}

	int code2;
	int cl,ch;

	cps2charset* pchs=(cps2charset*)chset;

	for (int i=0; i<=cps1_lso; i+=8)
	{
		signed short int x=READ_WORD(&c_pgfx[i]);
		signed short int y=READ_WORD(&c_pgfx[i+2]);
		int priority=(x>>13)&0x07;

		int code=READ_WORD(&c_pgfx[i+4]);
		int colour=READ_WORD(&c_pgfx[i+6]);
		int col=colour&0x1f;

		if ((priority>=minpri) && (priority<=maxpri))
		{
			code=code+((y & 0x6000) <<3);
			code%=chset->nSprites;

			x&=0x03ff; x^=0x200; x-=0x240;
			y&=0x03ff; y^=0x200; y-=0x210;

			if (colour & 0xff00)
			{
				int nx=(colour & 0x0f00) >> 8;
				int ny=(colour & 0xf000) >> 12;
				int nxs,nys,sx,sy;
				nx++;
				ny++;

				if (colour & 0x40)
				{
					if (colour &0x20)
					{
						for (nys=0; nys<ny; nys++)
						{
							for (nxs=0; nxs<nx; nxs++)
							{
								sx = x+nxs*16;
								sy = y+nys*16;

								code2=(code+(nx-1)-nxs+0x10*(ny-1-nys));

	//							if (code2<chset->nSprites)
								{
									if (do_ss==1)
									{
										cl=code2&0xff; ch=(code2>>8)&0xff;
										fwrite(&ch,1,1,ss); fwrite(&cl,1,1,ss);
									}

									pchs->printSprite(video,
										code2,col,
										sx,sy,
										1,1);
								}
							}
						}
					}
					else
					{
						for (nys=0; nys<ny; nys++)
						{
							for (nxs=0; nxs<nx; nxs++)
							{
								sx = x+nxs*16;
								sy = y+nys*16;

								code2=(code+nxs+0x10*(ny-1-nys));

	//							if (code2<pchs->nSprites)
								{
									if (do_ss==1)
									{
										cl=code2&0xff; ch=(code2>>8)&0xff;
										fwrite(&ch,1,1,ss); fwrite(&cl,1,1,ss);
									}

									pchs->printSprite(video,
										code2,col,
										sx,sy,
										0,1);
								}
							}
						}
					}
				}
				else
				{
					if (colour &0x20)
					{
						for (nys=0; nys<ny; nys++)
						{
							for (nxs=0; nxs<nx; nxs++)
							{
								sx = x+nxs*16;
								sy = y+nys*16;

								code2=(code+(nx-1)-nxs+0x10*nys);

	//							if (code2<pchs->nSprites)
								{
									if (do_ss==1)
									{
										cl=code2&0xff; ch=(code2>>8)&0xff;
										fwrite(&ch,1,1,ss); fwrite(&cl,1,1,ss);
									}

									pchs->printSprite(video,
										code2,col,
										sx,sy,
										1,0);
								}
							}
						}
					}
					else
					{
						for (nys=0; nys<ny; nys++)
						{
							for (nxs=0; nxs<nx; nxs++)
							{
								sx = x+nxs*16;
								sy = y+nys*16;

								code2=(code+nxs+0x10*nys);

	//							if (code2<pchs->nSprites)
								{
									if (do_ss==1)
									{
										cl=code2&0xff; ch=(code2>>8)&0xff;
										fwrite(&ch,1,1,ss); fwrite(&cl,1,1,ss);
									}

									pchs->printSprite(video,
										code2,col,
										sx,sy,
										0,0);
								}
							}
						}
					}
				}
			}
			else
			{
	//			if (code<pchs->nSprites)
				{
					if (do_ss==1)
					{
						cl=code&0xff; ch=(code>>8)&0xff;
						fwrite(&ch,1,1,ss); fwrite(&cl,1,1,ss);
					}

					pchs->printSprite(video,code,col,
						x,y,
						colour&0x20,colour&0x40);
				}
			}
		}
	}

	if (do_ss==1)
	{
		fclose(ss);
	}
}

/* helper draw function */

void cps2cpucore::draw_layer(int l,unsigned long int* video,tCharset* chset)
{
	if (l==1)
	{
		if (layer_enabled[1])
		{
			drawScroll1(video,chset);
		}
	}
	else if (l==2)
	{
		if (layer_enabled[2])
		{
			// rowscroll
			unsigned short int* prson=(unsigned short int*)&output_port[0x22];
			int rson=*prson&1;

			if (rson)
			{
				drawScroll2rs(video,chset);
			}
			else
			{
				drawScroll2(video,chset);
			}
		}
	}
	else if (l==3)
	{
		if (layer_enabled[3])
		{
			drawScroll3(video,chset);
		}
	}
}

/* quick load-save handler */

static const int ssendmarker=  0;
static const int sscps1ram=    1;
static const int ssgfxram=     2;
static const int ssoutput_port=3;
static const int ssqsoundram1= 4;
static const int ssobjram1=    5;
static const int ssobjram2=    6;
static const int ssobjoutput=  7;
static const int ssa68kstate=  8;
static const int ssz80prg=	   9;
static const int ssz80context=10;
static const int ssqsounddata=11;
static const int ssqsoundstatus=12;

/*  					   */

void cps2cpucore::checkquickstate()
{
	int tag;
	FILE* savestate;
	char ssname[128];

	strcpy(ssname,"save//");
	strcat(ssname,romname);
	strcat(ssname,"qs.sav");

	if (gui->ginput.quicksavestate==1)
	{
		gui->ginput.quicksavestate=0;

		savestate=fopen(ssname,"wb");
		if (savestate==0)
		{
			gui->printMessage(". unable to quicksave state");
			return ;
		}

		tag=sscps1ram;
		fwrite(&tag,4,1,savestate);
		fwrite(cps1ram,0x10000,1,savestate);

		tag=ssgfxram;
		fwrite(&tag,4,1,savestate);
		fwrite(gfxram,0x30000,1,savestate);

		tag=ssoutput_port;
		fwrite(&tag,4,1,savestate);
		fwrite(output_port,0x100,1,savestate);

		tag=ssqsoundram1;
		fwrite(&tag,4,1,savestate);
		fwrite(qsoundram1,0x1000,1,savestate);

		tag=ssobjram1;
		fwrite(&tag,4,1,savestate);
		fwrite(objram1,0x2000,1,savestate);

		tag=ssobjram2;
		fwrite(&tag,4,1,savestate);
		fwrite(objram2,0x2000,1,savestate);

		tag=ssobjoutput;
		fwrite(&tag,4,1,savestate);
		fwrite(objectoutput,0x0c,1,savestate);

		tag=ssa68kstate;
		fwrite(&tag,4,1,savestate);
		fwrite(&M68000_regs,sizeof(M68000_regs),1,savestate);

		tag=ssz80prg;
		fwrite(&tag,4,1,savestate);
		fwrite(z80prg,0x80000,1,savestate);

		tag=ssz80context;
		fwrite(&tag,4,1,savestate);
		fwrite(&ctx1,sizeof(CONTEXTMZ80),1,savestate);

		tag=ssqsounddata;
		fwrite(&tag,4,1,savestate);
		fwrite(&qsound_data,4,1,savestate);

		tag=ssqsoundstatus;
		qsoundSavestatus(savestate);

		// end of savestate
		tag=ssendmarker;
		fwrite(&tag,4,1,savestate);

		fclose(savestate);

		gui->printMessage(". quickstate saved");
	}
	if (gui->ginput.quickloadstate==1)
	{
		int exitflag=0;

		gui->ginput.quickloadstate=0;

		savestate=fopen(ssname,"rb");
		if (savestate==0)
		{
			gui->printMessage(". unable to open quicksave");
			return ;
		}

		while(!exitflag)
		{
			int tag;

			fread(&tag,4,1,savestate);

			if (tag==ssendmarker)
			{
				exitflag=1;
			}
			else if (tag==sscps1ram)
			{
				fread(cps1ram,0x10000,1,savestate);
			}
			else if (tag==ssgfxram)
			{
				fread(gfxram,0x30000,1,savestate);
			}
			else if (tag==ssoutput_port)
			{
				fread(output_port,0x100,1,savestate);
			}
			else if (tag==ssa68kstate)
			{
				fread(&M68000_regs,sizeof(M68000_regs),1,savestate);
				M68000_regs.IrqCallback=irqcall;
			}
			else if (tag==ssqsoundram1)
			{
				fread(qsoundram1,0x1000,1,savestate);
			}
			else if (tag==ssobjram1)
			{
				fread(objram1,0x2000,1,savestate);
			}
			else if (tag==ssobjram2)
			{
				fread(objram2,0x2000,1,savestate);
			}
			else if (tag==ssobjoutput)
			{
				fread(objectoutput,0x0c,1,savestate);
			}
			else if (tag==ssz80prg)
			{
				fread(z80prg,0x80000,1,savestate);
			}
			else if (tag==ssz80context)
			{
				// it is important that ctx is read *after* z80prg
				fread(&ctx1,sizeof(CONTEXTMZ80),1,savestate);
				ctx1.z80Base=z80prg;
				ctx1.z80IoRead=z80ReadPorts;
				ctx1.z80IoWrite=z80WritePorts;
				ctx1.z80MemRead=z80readmem;
				ctx1.z80MemWrite=z80writemem;
			}
			else if (tag==ssqsounddata)
			{
				fread(&qsound_data,4,1,savestate);
			}
			else if (tag==ssqsoundstatus)
			{
				qsoundLoadstatus(savestate);
			}
			else
			{
				exitflag=1;
			}
		}

		fclose(savestate);

		gui->printMessage(". quickstate loaded");
	}
}


/* main draw function */

void cps2cpucore::drawScreen(unsigned long int* video,tCharset* chset)
{
	// layer control states what's the layer to draw first
	// and in which order the others

	int l0,l1,l2,l3;
	int l0pri,l1pri,l2pri,l3pri;
	unsigned short int* lcp=(unsigned short int*)&output_port[0x66];

	unsigned short int* ppri=(unsigned short int*)&objectoutput[0x04];
	int pri_ctrl=*ppri;

	// layer draw order
	l0 = ((*lcp) >> 0x06) & 03;
	l1 = ((*lcp) >> 0x08) & 03;
	l2 = ((*lcp) >> 0x0a) & 03;
	l3 = ((*lcp) >> 0x0c) & 03;

	// layer draw priorities
	l0pri = (pri_ctrl >> 4*l0) & 0x0f;
	l1pri = (pri_ctrl >> 4*l1) & 0x0f;
	l2pri = (pri_ctrl >> 4*l2) & 0x0f;
	l3pri = (pri_ctrl >> 4*l3) & 0x0f;

	if (l0 == 0) { l0 = l1; l1 = 0; l0pri = l1pri; }
	if (l1 == 0) { l1 = l2; l2 = 0; l1pri = l2pri; }
	if (l2 == 0) { l2 = l3; l3 = 0; l2pri = l3pri; }

	//

	layer_enabled[0]=1;
	layer_enabled[1]=(*lcp)&0x02;
	layer_enabled[2]=(*lcp)&0x04;
	layer_enabled[3]=(*lcp)&0x08;

	//

	update_controls();
	build_palette(chset);
	cps2calc_lso();

	drawSprites(video,chset,0,0);
	drawSprites(video,chset,1,l0pri);
	draw_layer(l0,video,chset);
	drawSprites(video,chset,l0pri+1,l1pri);
	draw_layer(l1,video,chset);
	drawSprites(video,chset,l1pri+1,l2pri);
	draw_layer(l2,video,chset);
	drawSprites(video,chset,l2pri+1,7);
	draw_layer(l3,video,chset);

	checkquickstate();		//check load and save states
}

