
/*

  gui
  generic component class

*/


#ifndef COMPONENT_H
#define COMPONENT_H

#include "font.h"

// the structure that stores
// the "state" of the gui input

typedef struct
{
	int mouseXpos;
	int mouseYpos;
	int mousebutton1;
	int mousebutton2;

	int p1button[6];
	int p2button[6];
	int coin1,coin2;
	int start1,start2;
	int p1up,p1down,p1left,p1right;
	int p2up,p2down,p2left,p2right;

	int layeron[3];
	int paused;

	int quicksavestate;
	int quickloadstate;
} guiInput;

// the class

class tComponent
{
protected:

	int guiXsize;
	int guiYsize;

	int color;

public:

	int active;

	virtual void update(guiInput* gi);
	virtual void draw(unsigned long int* vbuf,tFont* f8x8,guiInput* gi);
	void resetguisize(int gxs,int gys);
	int isActive();
};

#endif