
/*

  siztem seecksteenz charset

*/

#include "s16charset.h"

//#define DEBUG
#define leftshift ((384-320)/2)

s16charset::s16charset(int nspr,int nchr,int nt16,int nt32,int objramsize)
{
	int i;

	gfx1=0;
	gfx2=0;
	nSprites=nspr;
	nChars=nchr;
	sprites=0;

	chars=new unsigned char* [nchr];

	for (i=0;i<nchr;i++)
	{
		chars[i]=new unsigned char [8*8];
		memset(chars[i],0,8*8);
	}

	obj=new unsigned char [objramsize];
	objsize=objramsize;
}

s16charset::~s16charset()
{
	if (gfx1!=0) delete [] gfx1;
	if (gfx2!=0) delete [] gfx2;

	if (chars!=0)
	{
		for (int j=0;j<nChars;j++)
		{
			if (chars[j]!=0) delete [] chars[j];
		}

		delete [] chars;
	}

	delete [] obj;
}

void s16charset::printbgChar(unsigned long int* vb,
							  int charnum,int color,
							  int xp,int yp,
							  int flipx,int flipy)
{
	if ( (xp<leftshift-7) || 
		 (xp>=(384-leftshift)) || 
		 (yp<-7) || (yp>=224) ) return;

	unsigned long int* pbmp=&vb[yp*384+xp];
	unsigned char* pchar=chars[charnum];
	int x,y;
	int c;

	unsigned long int* pcpal=(unsigned long int*)palette;

	if ( (xp>=leftshift) && 
		 (xp<(384-leftshift-8)) && 
		 (yp>=0) && 
		 (yp<(224-8)) )
	{
		for (y=0;y<8;y++)
		{
			for (x=0;x<8;x++)
			{
				c=*pchar;

//				if (c!=0)
				{
#ifdef DEBUG
					*pbmp=(c*32)|((c*32)<<8)|((c*32)<<16);
#else
					*pbmp=pcpal[c+color];
#endif
				}
				pbmp++;
				pchar++;
			}
			pbmp+=(384-8);
		}
	}
	else
	{
		for (y=0;y<8;y++)
		{
			if ((yp+y)>=224) return;
			for (x=0;x<8;x++)
			{
				c=*pchar;

				if ( ((xp+x)<(leftshift)) || ((xp+x)>=(384-leftshift)) || ((yp+y)<0) ) ;
				else /*if (c!=0)*/
				{
#ifdef DEBUG
					*pbmp=(c*32)|((c*32)<<8)|((c*32)<<16);
#else
					*pbmp=pcpal[c+color];
#endif
				}
				pbmp++;
				pchar++;
			}
			pbmp+=(384-8);
		}
	}
}

void s16charset::printfgChar(unsigned long int* vb,
							  int charnum,int color,
							  int xp,int yp,
							  int flipx,int flipy)
{
	if ( (xp<leftshift-7) || 
		 (xp>=(384-leftshift)) || 
		 (yp<-7) || (yp>=224) ) return;

	unsigned long int* pbmp=&vb[yp*384+xp];
	unsigned char* pchar=chars[charnum];
	int x,y;
	int c;

	unsigned long int* pcpal=(unsigned long int*)palette;

	if ( (xp>=leftshift) && 
		 (xp<(384-leftshift-8)) && 
		 (yp>=0) && 
		 (yp<(224-8)) )
	{
		for (y=0;y<8;y++)
		{
			for (x=0;x<8;x++)
			{
				c=*pchar;

				if (c!=0)
				{
#ifdef DEBUG
					*pbmp=(c*32)|((c*32)<<8)|((c*32)<<16);
#else
					*pbmp=pcpal[c+color];
#endif
				}
				pbmp++;
				pchar++;
			}
			pbmp+=(384-8);
		}
	}
	else
	{
		for (y=0;y<8;y++)
		{
			if ((yp+y)>=224) return;
			for (x=0;x<8;x++)
			{
				c=*pchar;

				if ( ((xp+x)<(leftshift)) || ((xp+x)>=(384-leftshift)) || ((yp+y)<0) ) ;
				else if (c!=0)
				{
#ifdef DEBUG
					*pbmp=(c*32)|((c*32)<<8)|((c*32)<<16);
#else
					*pbmp=pcpal[c+color];
#endif
				}
				pbmp++;
				pchar++;
			}
			pbmp+=(384-8);
		}
	}
}

void s16charset::printSprite(unsigned long int* video,
					 int charnum,int color,
					 int xp,int yp,
					 int xs,int ys,
					 int flipx,int flipy,
					 int zoomx,int zoomy)
{
	if ( (xp>=(384-leftshift)) || (yp<-ys) || (yp>=224) ) return;

	int x,y,c;
	unsigned long int* pcpal=(unsigned long int*)palette;
	unsigned long int* vp;
	int startoffs,pos;
	int padder=objsize-1;

	color=color|0x400;

	startoffs=charnum-29;

	if (flipx) startoffs+=4;
	else startoffs+=xs;

	if (flipy) startoffs-=xs*ys;

	if ( (!flipx) && (!flipy) )
	{
		pos=startoffs;

		for (y=0;y<ys;y++)
		{
			if ((y+yp)>=224) return ;

			vp=&video[(leftshift+xp)+(y+yp)*384];

			for (x=0;x<xs;x++)
			{
				c=obj[pos&padder];

				if (c) 
				{
					if ( ((x+xp)>=0) && ((x+xp)<(384-2*leftshift)) )
					{
						*vp=pcpal[c+color];
					}
				}

				vp++;
				pos++;
			}
		}
	}
	else if ( (flipx) && (!flipy) )
	{
		pos=startoffs+xs;

		for (y=0;y<ys;y++)
		{
			if ((y+yp)>=224) return ;

			vp=&video[(leftshift+xp)+(y+yp)*384];

			for (x=0;x<xs;x++)
			{
				c=obj[pos&padder];

				if (c) 
				{
					if ( ((x+xp)>=0) && ((x+xp)<(384-2*leftshift)) )
					{
						*vp=pcpal[c+color];
					}
				}

				vp++;
				pos--;
			}
			pos+=xs*2;
		}
	}
	else if ( (!flipx) && (flipy) )
	{
		pos=startoffs+((ys-2)*xs);

		for (y=0;y<ys;y++)
		{
			if ((y+yp)>=224) return ;
			vp=&video[(leftshift+xp)+(y+yp)*384];

			for (x=0;x<xs;x++)
			{
				c=obj[pos&padder];

				if (c) 
				{
					if ( ((x+xp)>=0) && ((x+xp)<(384-2*leftshift)) )
					{
						*vp=pcpal[c+color];
					}
				}

				vp++;
				pos++;
			}
			pos-=xs*2;
		}
	}
	else if ( (flipx) && (flipy) )
	{
		pos=startoffs+(ys-1)*xs;

		for (y=0;y<ys;y++)
		{
			if ((y+yp)>=224) return ;
			vp=&video[(leftshift+xp)+(y+yp)*384];

			for (x=0;x<xs;x++)
			{
				c=obj[pos&padder];

				if (c) 
				{
					if ( ((x+xp)>=0) && ((x+xp)<(384-2*leftshift)) )
					{
						*vp=pcpal[c+color];
					}
				}

				vp++;
				pos--;
			}
		}
	}
}
