
/*

  system bar

*/


#include "sysbar.h"

extern tGui* gui;


tSysbar::tSysbar(int col,int fontcol,int h,int gxs,int gys)
{
	menuclicked=0;
	menuover=0;
	fontcolor=fontcol;
	color=col;
	height=h;
	guiXsize=gxs;
	guiYsize=gys;
	active=1;
}

void tSysbar::update(guiInput* gi)
{
	// (for now) check mouse in the menu area

	int logox1,logox2,logoy1,logoy2;
	int mx,my;

	if ( (gui->guiinfo.videomode==1) || (gui->guiinfo.videomode==2) )
	{
		logox1=0;logox2=60;

		if (gui->orientation==VIDEO_NORMAL)
		{
			logoy2=guiYsize*2; 
			logoy1=guiYsize*2-48;
		}
		else if (gui->orientation==VIDEO_ROT90)
		{
			logoy2=guiYsize*2-175; 
			logoy1=guiYsize*2-195;
		}

		mx=gi->mouseXpos;
		my=gi->mouseYpos;
	}
	else if (gui->guiinfo.videomode==0)
	{
		logox1=0;logox2=30;
		
		if (gui->orientation==VIDEO_NORMAL)
		{
			logoy2=guiYsize-20; 
			logoy1=guiYsize-30;
		}
		else if (gui->orientation==VIDEO_ROT90)
		{
			logox1+=200;
			logox2+=200;
			logoy1=guiYsize-35;
			logoy2=guiYsize-25; 
		}

		mx=gi->mouseXpos;
		my=gi->mouseYpos-20;
	}
	else if ( (gui->guiinfo.videomode==3) || (gui->guiinfo.videomode==4) )
	{
		logox1=0;logox2=30;
		
		if (gui->orientation==VIDEO_NORMAL)
		{
			logoy2=guiYsize-20; 
			logoy1=guiYsize-30;
		}
		else if (gui->orientation==VIDEO_ROT90)
		{
			logoy2=guiYsize-25; 
			logoy1=guiYsize-35;
		}
		
		mx=gi->mouseXpos;
		my=gi->mouseYpos;
	}

	if ( (mx>=logox1) && (mx<=logox2) && (my>=logoy1) && (my<logoy2) )
	{
		menuover=1;

		if (gi->mousebutton1==1)
		{
			menuclicked=1;
			gi->mousebutton1=0;		//ack event (?)
		}
		else
		{
			menuclicked=0;
		}
	}
	else
	{
		menuover=0;
	}
}

void tSysbar::drawRect(int x1,int y1,int x2,int y2,int col,unsigned long int* vbuf)
{
	for (int r=y1;r<y2;r++)
	{
		for (int c=x1;c<x2;c++)
		{
			vbuf[r*guiXsize+c]=col;
		}
	}

}

void tSysbar::drawSolidRect(int x1,int y1,int x2,int y2,int col,unsigned long int* vbuf)
{
	for (int r=y1;r<y2;r++)
	{
		for (int c=x1;c<x2;c++)
		{
			vbuf[r*guiXsize+c]=col;
		}
	}

}

void tSysbar::drawBox(int x1,int y1,int x2,int y2,int col,unsigned long int* vbuf)
{
	// upper and lower lines
	for (int x=x1;x<=x2;x++)
	{
		vbuf[y1*guiXsize+x]=col;
		vbuf[y2*guiXsize+x]=col;
	}

	// left and right lines
	for (int y=y1;y<y2;y++)
	{
		vbuf[y*guiXsize+x1]=col;
		vbuf[y*guiXsize+x2]=col;
	}
}


void tSysbar::draw(unsigned long int* vbuf,tFont* f8x8,guiInput* gi)
{
	// height of the gui should be proportional
	// to screen dimension
	// ...

	int r1,g1,b1,lcolor;
	r1=color&0xff; g1=(color>>8)&0xff; b1=(color>>16)&0xff;
	lcolor=r1|(g1<<8)|(b1<<16);

	// the lower rectangle
	for (int i=((guiYsize-height)*guiXsize);i<(guiXsize*guiYsize);i++)
	{
		vbuf[i]=lcolor;
	}

	// the upper line
	r1=clamp((color&0xff)+20);
	g1=clamp(((color>>8)&0xff)+20);
	b1=clamp(((color>>16)&0xff)+20);
	lcolor=r1|(g1<<8)|(b1<<16);

	for (i=((guiYsize-height)*guiXsize);i<((guiYsize-height)*guiXsize+guiXsize);i++)
	{
		vbuf[i]=lcolor;
	}

	// the logo! and the version
	// should we enlight the logo?

	if (menuover)
	{
		// draw the rectangle under "ace" logo
		drawSolidRect(2,guiYsize-height+1,28,guiYsize,0x9292c2,vbuf);
//		drawBox(2,guiYsize-height+1,28,guiYsize,0x424282,vbuf);
	}

	f8x8->drawString("Ace",fontcolor,3,guiYsize-height+2,guiXsize,guiYsize,vbuf);


	char strfps[64];
	sprintf(strfps,"fskp %d fps %3.3d",gui->guiinfo.frameskip-1,(int)gui->onscreenfps);

	f8x8->drawString(strfps,fontcolor,guiXsize-118,guiYsize-height+2,guiXsize,guiYsize,vbuf);

//	f8x8->drawString("gui v1.1",fontcolor,guiXsize-68,guiYsize-height+2,guiXsize,guiYsize,vbuf);

/*
	int mxp,myp;
	char smxp[10];
	char smyp[10];
	char fs[256];

	mxp=gi->mouseXpos;
	myp=gi->mouseYpos;

	sprintf(smxp,"%d",mxp);
	sprintf(smyp,"%d",myp);

	sprintf(fs,"%s %s",smxp,smyp);

	f8x8->drawString(fs,fontcolor,guiXsize-128,guiYsize-height+2,guiXsize,guiYsize,vbuf);
*/
}

