/*

  the romspace

*/

#ifndef ROMSPACE_H
#define ROMSPACE_H

#include "unzip.h"
#include "charset.h"
#include "roms.h"

class tRomSpace
{
protected:

	void readError(char* zipfile,char* romfile);
	int loadZippedRom(char* zipfile,char* romfile,unsigned long int size,
		              unsigned long int crc32,unsigned char* dest);
	int romsetByName(char* romsetname,int* rs);
	unsigned long int getGromSize(tRomSet* rsp);

	int readbit(const unsigned char *src,int bitnum);

public:

	unsigned char* romCPU1;
	unsigned char* romCPU2;
	unsigned char* romadpcm;
	unsigned char* romqsound;

	char romname[64];
	int romsettype;
	int orientation;
	int kludge;
	unsigned long int gromsize;

	int nspr;
	int nchars;
	int ntile16;
	int ntile32;

	int sprmagic1,sprmagic2;
	int charmagic1;
	int tile16magic1,tile16magic2;
	int tile32magic1,tile32magic2;

	int sproffs,charoffs,tile16offs,tile32offs;
	int charbase,tile16base,tile32base;
	int charpad,tile16pad,tile32pad;

	unsigned long int protport,protval;
	unsigned long int multlo,multhi,fac1,fac2;
	int layercontrol;

	tRomSpace();
	virtual ~tRomSpace();
	virtual int readRoms(char* path,char* romsetname,tCharset**);
	virtual void decodeCharset(tCharset*);
} ;


#endif