 
/*
	
	  video class implementation
	  28/10/2001

*/ 


#include "videowin.h"
#include "../gui.h"


// global variables used for testing

int do_ss=0;
int goshift=0;
int multiply=0;

// gui & video interface

extern tGui* gui;
extern video* vid;

// window x/y sizes for different modes
// (and for rotated games as well)

static int x_res[5]  = {400,384*2,384*2,384,384};
static int y_res[5]  = {300,224*2,224*2,224,224};
static int rx_res[5] = {640,224*2,224*2,224,224};
static int ry_res[5] = {480,384*2,384*2,384,384};

// local variables (not in the class for shitty C windows functions)

static RECT g_rcScreen;
static HWND hwin;
static int g_videomode;

// application name

const char* appName="a.c.e. v1.8 (l'emulatore candeggina)";


//
// constructor
//

videowin::videowin()
{
	g_videomode=-1;
	vbufx=0;
	vbufy=0;
	g_pDD2=0;
	g_pDD2SPrimary=0;
	g_pDD2SBack=0;
}

// set viewport

void videowin::setViewport(int vbx,int vby)
{
	vbufx=vbx;
	vbufy=vby;
}

//
// blitter
//

void videowin::blit(unsigned long int* buf)
{
	if (g_videomode==0)
	{
		HRESULT hres;
		unsigned long int* pBits;
		unsigned long int* pSrc=buf;
		DDSURFACEDESC ddsd1;
		memset(&ddsd1,0,sizeof(ddsd1));
		ddsd1.dwSize=sizeof(ddsd1);

		g_pDD2SBack->GetSurfaceDesc(&ddsd1);

		if (gui->orientation==VIDEO_NORMAL)
		{
		    hres=g_pDD2SBack->Lock(NULL,&ddsd1,DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT,NULL);
			if (hres==DD_OK)
			{
				pBits=(unsigned long int*)ddsd1.lpSurface;
				int ptc=ddsd1.lPitch/4;
				unsigned long int* ppbits;

				for (int i=0;i<vbufy;i++)
				{
					int yv=((y_res[g_videomode]-vbufy)/2)*x_res[g_videomode]+ptc*i;
					ppbits=&pBits[yv+((x_res[g_videomode]-vbufx)/2)];

					memcpy(ppbits,pSrc,vbufx*4);
					pSrc+=vbufx;
				}
			
				g_pDD2SBack->Unlock(NULL);
			}
		}
		else if (gui->orientation==VIDEO_ROT90)
		{
			hres=g_pDD2SBack->Lock(NULL,&ddsd1,DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT,NULL);
			if (hres==DD_OK)
			{
				int ptch=(ddsd1.lPitch/4);
				unsigned long int* pBits=(unsigned long int*)ddsd1.lpSurface;

				int y;
				unsigned long int *psl,*pdl;

				int midx=((rx_res[g_videomode]-vbufx)/2);
				int midy=((ry_res[g_videomode]-vbufy)/2);

				psl=&pSrc[383];
				pdl=pBits+midx+(midy*ptch/4);

				for (y=0;y<vbufx;y++,psl--,pdl+=ptch)
				{
					unsigned long int *ps,*pd; 
					int x;
					ps=psl; 
					pd=pdl;

					for (x=0;x<vbufy;x++,ps+=vbufx,pd++)
					{ 
						*pd=*ps;
					}
				}
			}
			g_pDD2SBack->Unlock(NULL);
		}

		// flip
		g_pDD2SPrimary->Flip(0,0);
	}
	else if ( (g_videomode==1) || (g_videomode==3) )
	{
		HRESULT hres;
		DDSURFACEDESC ddsd1;
		unsigned long int* pSrc=buf;

		memset(&ddsd1,0,sizeof(ddsd1));
		ddsd1.dwSize=sizeof(ddsd1);

		g_pDD2SBack->GetSurfaceDesc(&ddsd1);

		if (gui->orientation==VIDEO_NORMAL)
		{
			if (oldresBPP==16)
			{
			    hres=g_pDD2SBack->Lock(NULL,&ddsd1,DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT,NULL);
				if (hres==DD_OK)
				{
					const int sh=ddsd1.lPitch/4-(vbufx/2);
					unsigned long int* pBits=(unsigned long int*)ddsd1.lpSurface;
					unsigned char* pps=(unsigned char*)pSrc;
					unsigned long int fcol;

					for (int i=0;i<vbufy;i++)
					{
						for (int l=0;l<vbufx/2;l++)
						{
							int r1,g1,b1,r2,b2,g2;

							r1=pps[0]>>3;
							g1=(pps[1]>>2)<<5;
							b1=(pps[2]>>3)<<11;
							r2=(pps[4]>>3)<<16;
							g2=(pps[5]>>2)<<21;
							b2=(pps[6]>>3)<<27;

							fcol=r1|g1|b1|r2|g2|b2;
							*pBits=fcol;
							pBits++;
							pps+=8;
						}
						pBits+=sh;
					}
				
					g_pDD2SBack->Unlock(NULL);
				}
			}
			else if (oldresBPP==32)
			{
			    hres=g_pDD2SBack->Lock(NULL,&ddsd1,DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT,NULL);
				if (hres==DD_OK)
				{
					unsigned long int* pBits=(unsigned long int*)ddsd1.lpSurface;
					int ptch=ddsd1.lPitch/4;
					int yoff=0;
					unsigned long int* ppbits;

					for (int i=0;i<vbufy;i++)
					{
						ppbits=&pBits[yoff];

						memcpy(ppbits,pSrc,vbufx*4);
						pSrc+=vbufx;
						yoff+=ptch;
					}
				
					g_pDD2SBack->Unlock(NULL);
				}
			}
		}
		else if (gui->orientation==VIDEO_ROT90)
		{
			if (oldresBPP==16)
			{
			    hres=g_pDD2SBack->Lock(NULL,&ddsd1,DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT,NULL);
				if (hres==DD_OK)
				{
					int ptch=(ddsd1.lPitch/2);
					unsigned short int* pBits=(unsigned short int*)ddsd1.lpSurface;

					int y;
					unsigned char *psl;
					unsigned short int *pdl;
					psl=(unsigned char*)&pSrc[383];
					pdl=pBits;

					for (y=0;y<vbufx;y++,psl-=4,pdl+=ptch)
					{
						unsigned char *ps;
						unsigned short int *pd; 
						int x;
						ps=psl; 
						pd=pdl;

						for (x=0;x<vbufy;x++,ps+=vbufx*4,pd++)
						{ 
							int r1,g1,b1;

							r1=ps[0]>>3;
							g1=(ps[1]>>2)<<5;
							b1=(ps[2]>>3)<<11;

							*pd=r1|g1|b1;
						}
					}
					g_pDD2SBack->Unlock(NULL);
				}
			}
			else if (oldresBPP==32)
			{
			    hres=g_pDD2SBack->Lock(NULL,&ddsd1,DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT,NULL);
				if (hres==DD_OK)
				{
					int ptch=(ddsd1.lPitch/4);
					unsigned long int* pBits=(unsigned long int*)ddsd1.lpSurface;

					int y;
					unsigned long int *psl,*pdl;
					psl=&pSrc[383];
					pdl=pBits;

					for (y=0;y<vbufx;y++,psl--,pdl+=ptch)
					{
						unsigned long int *ps,*pd; 
						int x;
						ps=psl; 
						pd=pdl;

						for (x=0;x<vbufy;x++,ps+=vbufx,pd++)
						{ 
							*pd=*ps;
						}
					}
				}
				g_pDD2SBack->Unlock(NULL);
			}
		}

		// flip screen
		hres=g_pDD2SPrimary->Blt(&g_rcScreen,g_pDD2SBack,0,DDBLT_WAIT,NULL);
	}
}

// buffer clearer

void videowin::clear(unsigned long int* buf)
{
	memset(buf,0x0,vbufx*vbufy*4);
}

//
// remap cursor position according to videomode
//

void videowin::remapCursor(int vm,int* xp,int* yp)
{
	if (vm==0)
	{
		*xp=*xp-((x_res[vm]-vbufx)/2);
		*yp=*yp-(y_res[vm]-vbufy)/2;
	}
	else if (vm==1)
	{
		//doubled
		*xp=*xp/2;
		*yp=*yp/2;
		
		*yp=(int)((float)(*yp)*1.06);
	}
}

//
// window proc
//

long CALLBACK WindowProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{
	int nVirtKey;
	int lKeyData;

	switch (message)
	{
		case WM_CREATE:
		{
			break;
		}
		case WM_DESTROY: 
		{
			if (!gui->changingmode)
			{
				gui->exitp=1;
			}
			PostQuitMessage(0);
			break;
		}
		case WM_PAINT:
		{
			break;
		}
		case WM_MOVE:
		{
			if ( (g_videomode==1) || (g_videomode==3) )
			{
				GetClientRect(hWnd, &g_rcScreen);
				ClientToScreen(hWnd, (POINT*)&g_rcScreen.left);
				ClientToScreen(hWnd, (POINT*)&g_rcScreen.right);
			}
			break;
		}
		case WM_MOUSEWHEEL:
		{
			int zDelta = (short) HIWORD(wParam);

			if (zDelta>0)
			{
				gui->ginput.mousewheelup=1;
			}
			else
			{
				gui->ginput.mousewheeldown=1;
			}
			break;
		}
		case WM_LBUTTONDOWN:
		{
			// inform the gui of this
			gui->lButtonDown();
			break;
		}
		case WM_LBUTTONUP:
		{
			// inform the gui of this
			gui->lButtonUp();
			break;
		}
		case WM_RBUTTONDOWN:
		{
			// inform the gui of this
			gui->rButtonDown();
			break;
		}
		case WM_RBUTTONUP:
		{
			// inform the gui of this
			gui->rButtonUp();
			break;
		}
		case WM_MOUSEMOVE:
		{
			int xpos,ypos;

			xpos=LOWORD(lParam);
			ypos=HIWORD(lParam);

/*			POINT cp;
			GetCursorPos(&cp);
			ScreenToClient(hWnd,&cp);
			xpos=cp.x;
			ypos=cp.y;
*/
			((videowin*)vid)->remapCursor(g_videomode,&xpos,&ypos);
			gui->mouseMove(xpos,ypos);

			break;
		}
		case WM_KEYDOWN:
		{
			// for some keys we should control
			// if the key is being just repeated

			nVirtKey=(int)wParam;
			lKeyData = lParam;   

			if (nVirtKey=='P')
			{
				gui->ginput.paused=!gui->ginput.paused;
			}
			if (nVirtKey=='1')
			{
				gui->ginput.layeron[0]=!gui->ginput.layeron[0];	
			}
			if (nVirtKey=='2')
			{
				gui->ginput.layeron[1]=!gui->ginput.layeron[1];	
			}
			if (nVirtKey=='3')
			{
				gui->ginput.layeron[2]=!gui->ginput.layeron[2];	
			}
			if (nVirtKey==VK_F11)
			{
				gui->ginput.quickloadstate=1;
			}
			if (nVirtKey==VK_F12)
			{
				gui->ginput.quicksavestate=1;
			}
			if (nVirtKey==VK_F8)
			{
				do_ss=1;
			}
			if (nVirtKey==VK_F4)
			{
				goshift-=0x10;
			}
			if (nVirtKey==VK_F5)
			{
				goshift+=0x10;
			}
			if (nVirtKey==VK_F6)
			{
				goshift-=0x10;
			}
			if (nVirtKey==VK_F7)
			{
				goshift+=0x10;
			}

			if (nVirtKey==VK_F3)	//coin p1
			{
				gui->ginput.coin1=1;
			}
			if (nVirtKey==VK_F1)	//start p1
			{
				gui->ginput.start1=1;
			}

			if (nVirtKey==VK_LEFT)
			{
				gui->ginput.p1left=1;
			}
			if (nVirtKey==VK_RIGHT)
			{
				gui->ginput.p1right=1;
			}
			if (nVirtKey==VK_UP)
			{
				gui->ginput.p1up=1;
			}
			if (nVirtKey==VK_DOWN)
			{
				gui->ginput.p1down=1;
			}
			// buttons
			if (nVirtKey=='A')
			{
				gui->ginput.p1button[0]=1;
			}
			if (nVirtKey=='S')
			{
				gui->ginput.p1button[1]=1;
			}
			if (nVirtKey=='D')
			{
				gui->ginput.p1button[2]=1;
			}
			if (nVirtKey=='Z')
			{
				gui->ginput.p1button[3]=1;
			}
			if (nVirtKey=='X')
			{
				gui->ginput.p1button[4]=1;
			}
			if (nVirtKey=='C')
			{
				gui->ginput.p1button[5]=1;
			}
			// trim speed key (backspace)
			if (nVirtKey==VK_BACK)
			{
				gui->guiinfo.trimspeed=!gui->guiinfo.trimspeed;
				if (gui->guiinfo.trimspeed)
				{
					gui->printMessage(". trimspeed on");
				}
				else
				{
					gui->printMessage(". trimspeed off");
				}
			}
			break;
		}
		case WM_KEYUP:
		{
			nVirtKey=(int)wParam;
			lKeyData = lParam;   

			if (nVirtKey==VK_F8)
			{
				do_ss=0;
			}
			if (nVirtKey==VK_F3)	//coin p1
			{
				gui->ginput.coin1=0;
			}
			if (nVirtKey==VK_F1)	//start p1
			{
				gui->ginput.start1=0;
			}

			if (nVirtKey==VK_LEFT)
			{
				gui->ginput.p1left=0;
			}
			if (nVirtKey==VK_RIGHT)
			{
				gui->ginput.p1right=0;
			}
			if (nVirtKey==VK_DOWN)
			{
				gui->ginput.p1down=0;
			}
			if (nVirtKey==VK_UP)
			{
				gui->ginput.p1up=0;
			}
			// buttons
			if (nVirtKey=='A')
			{
				gui->ginput.p1button[0]=0;
			}
			if (nVirtKey=='S')
			{
				gui->ginput.p1button[1]=0;
			}
			if (nVirtKey=='D')
			{
				gui->ginput.p1button[2]=0;
			}
			if (nVirtKey=='Z')
			{
				gui->ginput.p1button[3]=0;
			}
			if (nVirtKey=='X')
			{
				gui->ginput.p1button[4]=0;
			}
			if (nVirtKey=='C')
			{
				gui->ginput.p1button[5]=0;
			}

			break;
		}
	}

	return DefWindowProc(hWnd, message, wParam, lParam);
}


void videowin::setHinstance(HINSTANCE hi)
{
	hinst=hi;
}

//
// init of display
// should support re-init (being called twice)
// videomode: 0 dx fullscreen, 1 dx window, 2 gdi window
//

int videowin::init(unsigned long int** vbuf,int videomode,int orientation) 
{
	WNDCLASS wc;
	HRESULT hres;

	int dimx;
	int dimy;

	// check if this is a re-init

	if (g_videomode!=-1)
	{
		// dispose old video
		unsigned long int* vb=*vbuf;
		delete [] vb;

		if (g_videomode==0)
		{
			g_pDD2->SetDisplayMode(oldresX,oldresY,oldresBPP, 0, 0);
		}
		if (g_pDD2 != NULL)
		{
			if (g_pDD2SPrimary != NULL)
			{
				g_pDD2SPrimary->Release();
				g_pDD2SPrimary = NULL;
			}

			g_pDD2->Release();
			g_pDD2 = NULL;
		}

        FreeLibrary(hdll);

		// delete old win
		DestroyWindow(hwin);
	}

	// store videomode

	g_videomode=videomode;

	// video buffer allocation
	// (where the emulation functions write)

	*vbuf=new unsigned long int [vbufx*vbufy];
	memset(*vbuf,0,vbufx*vbufy*4);

	// set up window dimensions

	if (orientation==VIDEO_NORMAL)
	{
		dimx=x_res[videomode];
		dimy=y_res[videomode];
	}
	else 
	{
		dimx=rx_res[videomode];
		dimy=ry_res[videomode];
	}

	// create different windows
	// for different videomodes

	// dx fullscreen 
	if (videomode==0)
	{
		wc.style=CS_HREDRAW|CS_VREDRAW;
		wc.lpfnWndProc=WindowProc;
		wc.cbClsExtra=0;
		wc.cbWndExtra=0;
		wc.hInstance=hinst;
		wc.hIcon=LoadIcon(hinst,NULL);
		wc.hCursor=LoadCursor(0, IDC_ARROW);
		wc.hbrBackground=(struct HBRUSH__ *)GetStockObject(BLACK_BRUSH);
		wc.lpszMenuName=0;
		wc.lpszClassName="emu";
		RegisterClass(&wc);

		RECT r;
		r.top=0;
		r.left=0;
		r.bottom=r.top+dimy;
		r.right=r.left+dimx;

		unsigned long style=WS_POPUP;
		unsigned long styleex=0;

		hwin=CreateWindowEx(styleex,"emu",appName,style,
					        r.left,r.top,
							r.right,r.bottom,
							NULL,NULL,hinst,NULL);

		if (!hwin) 
		{
			MessageBox(0,"error","unable to create window",MB_OK);
			return 1;
		}

		ShowWindow(hwin,SW_SHOW);
		UpdateWindow(hwin);
		SetFocus(hwin);
	}
	// dx window
	else if ( (videomode==1) || (videomode==3) ) 
	{
		//display window

		wc.style=CS_HREDRAW|CS_VREDRAW;
		wc.lpfnWndProc=WindowProc;
		wc.cbClsExtra=0;
		wc.cbWndExtra=0;
		wc.hInstance=hinst;
		wc.hIcon=LoadIcon(hinst,NULL);
		wc.hCursor=LoadCursor(0, IDC_ARROW);
		wc.hbrBackground=(struct HBRUSH__ *)GetStockObject(BLACK_BRUSH);
		wc.lpszMenuName=0;
		wc.lpszClassName="emu";
		RegisterClass(&wc);

		RECT r;

		r.left=0;
		r.top=0;
		r.bottom=dimy;
		r.right=dimx;

		unsigned long style=WS_OVERLAPPED;
		unsigned long styleex=0;

		hwin = CreateWindowEx(styleex,"emu",appName,style,
							  r.left,r.top,r.right,r.bottom,
							  NULL,NULL,hinst,NULL);
		if (!hwin) 
		{
			MessageBox(0,"error","unable to create window",MB_OK);
			return 1;
		}

		int xs=GetSystemMetrics(SM_CXSCREEN);
		int ys=GetSystemMetrics(SM_CYSCREEN);

		if (orientation==VIDEO_NORMAL)
		{
			SetWindowPos(hwin,HWND_TOP,
						 (xs-dimx)/2,
						 (ys-dimy)/2,
						 0,0,SWP_NOSIZE);
		}
		else
		{
			SetWindowPos(hwin,HWND_TOP,
						 (xs-dimx)/2,
						 10,
						 0,0,SWP_NOSIZE);
		}
		ShowWindow(hwin,SW_SHOW);
		UpdateWindow(hwin);
		SetFocus(hwin);
	}
	else
	{
		MessageBox(0,"error","unsupported videomode (check ace.ini)",MB_OK);
		return 1;
	}

	//
	// set up dx and surfaces
	//

	if (videomode==0)
	{
	    DDSURFACEDESC ddsd1;
		IDirectDraw* dd_directx1;
		typedef HRESULT (WINAPI* ddc_proc)(GUID FAR *lpGUID,        
										   LPDIRECTDRAW FAR *lplpDD,  
										   IUnknown FAR *pUnkOuter); 

		ddc_proc ddcreateFunc;

	    hdll=LoadLibrary("ddraw.dll");
		if (hdll==NULL)
		{
			MessageBox(NULL,"error","unable to load ddraw.dll",MB_OK);
			return 1;
		}

		// attach function
		ddcreateFunc=(ddc_proc)GetProcAddress(hdll, "DirectDrawCreate");
		if (ddcreateFunc == NULL)
		{
			MessageBox(NULL,"error","unable to attach DirectDrawCreate",MB_OK);
			return 1;
		}

		// create dx interface object
		hres=ddcreateFunc(NULL,&dd_directx1,NULL);
		if (hres!=DD_OK)
		{
			MessageBox(NULL,"error","unable to create DX interface",MB_OK);
			return 1;
		}

		//
		hres=dd_directx1->QueryInterface(IID_IDirectDraw2,(void **)&g_pDD2);
		if (hres!=DD_OK)
		{
			MessageBox(NULL,"error","unable to query DX interface",MB_OK);
			return 1;
		}
		dd_directx1->Release();
 
		// try to guess which videomode and bpp are we using

		DDSURFACEDESC sd;
		memset(&sd,0,sizeof(sd));
		sd.dwSize=sizeof(sd);
		hres=g_pDD2->GetDisplayMode(&sd);
		if (hres!=DD_OK)
		{
			MessageBox(NULL,"error","unable to get video mode",MB_OK);
			return 1;
		}

		oldresX=sd.dwWidth;
		oldresY=sd.dwHeight,
		oldresBPP=sd.ddpfPixelFormat.dwRGBBitCount;

		// set cooperative level
		hres=g_pDD2->SetCooperativeLevel(hwin,DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN);
		if (hres!=DD_OK)
		{
			MessageBox(NULL,"error","unable to set cooperative level",MB_OK);
			return 1;
		}

		// set videomode
		hres=g_pDD2->SetDisplayMode(dimx,dimy,32,0,0);
		if (hres!=DD_OK)
		{
			MessageBox(NULL,"error","unable to set fullscreen display mode",MB_OK);
			return 1;
		}

		// Create the primary surface with 1 back buffer
		ZeroMemory(&ddsd1, sizeof(ddsd1));
		ddsd1.dwSize = sizeof(ddsd1);
		ddsd1.dwHeight=dimy;
		ddsd1.dwWidth=dimx;
		ddsd1.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
		ddsd1.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
                			  DDSCAPS_FLIP |
                			  DDSCAPS_COMPLEX;
        ddsd1.dwBackBufferCount = 1;

		hres=g_pDD2->CreateSurface(&ddsd1,&g_pDD2SPrimary,NULL);
		if (hres != DD_OK)
		{
			char err[256];
			sprintf(err,"primary surface err %d",hres);
			g_pDD2->SetDisplayMode(oldresX,oldresY,oldresBPP, 0, 0);
			MessageBox(NULL,"error",err,MB_OK);
			return 1;
		}

		// create backbuffer
		memset(&ddsd1.ddsCaps,0,sizeof(ddsd1.ddsCaps));
		ddsd1.ddsCaps.dwCaps=DDSCAPS_BACKBUFFER; 
        hres = g_pDD2SPrimary->GetAttachedSurface(&ddsd1.ddsCaps, &g_pDD2SBack);
		if (hres != DD_OK)
		{
			g_pDD2->SetDisplayMode(oldresX,oldresY,oldresBPP, 0, 0);
			MessageBox(NULL,"error","secondary surface",MB_OK);
			return 1;
		}

		// fill surfaces with black 

		DDBLTFX ddbltfx; 
	    ddbltfx.dwSize = sizeof(ddbltfx); 
		ddbltfx.dwFillColor = 0;
		g_pDD2SPrimary->Blt(0,0,0,DDBLT_COLORFILL,&ddbltfx);
		g_pDD2SBack->Blt(0,0,0,DDBLT_COLORFILL,&ddbltfx);
	}
	else if ( (videomode==1) || (videomode==3) )
	{
		IDirectDraw* dd_directx1;
		typedef HRESULT (WINAPI* ddc_proc)(GUID FAR *lpGUID,        
										   LPDIRECTDRAW FAR *lplpDD,  
										   IUnknown FAR *pUnkOuter); 
		ddc_proc ddcreateFunc;

	    hdll=LoadLibrary("ddraw.dll");
		if (hdll==NULL)
		{
			MessageBox(NULL,"error","unable to load ddraw.dll",MB_OK);
			return 1;
		}

		// attach function
		ddcreateFunc=(ddc_proc)GetProcAddress(hdll, "DirectDrawCreate");
		if (ddcreateFunc == NULL)
		{
			MessageBox(NULL,"error","unable to attach DirectDrawCreate",MB_OK);
			return 1;
		}

		// create dx interface object
		hres=ddcreateFunc(NULL,&dd_directx1,NULL);
		if (hres!=DD_OK)
		{
			MessageBox(NULL,"error","unable to create DX interface",MB_OK);
			return 1;
		}

		//
		hres=dd_directx1->QueryInterface(IID_IDirectDraw2,(void **)&g_pDD2);
		if (hres!=DD_OK)
		{
			MessageBox(NULL,"error","unable to query DX interface",MB_OK);
			return 1;
		}
		dd_directx1->Release();
 
		// try to guess which videomode and bpp are we using

		DDSURFACEDESC sd;
		memset(&sd,0,sizeof(sd));
		sd.dwSize=sizeof(sd);
		hres=g_pDD2->GetDisplayMode(&sd);
		if (hres!=DD_OK)
		{
			MessageBox(NULL,"error","unable to get video mode",MB_OK);
			return 1;
		}

		oldresX=sd.dwWidth;
		oldresY=sd.dwHeight,
		oldresBPP=sd.ddpfPixelFormat.dwRGBBitCount;

		if ( (oldresBPP!=16) && (oldresBPP!=32) )
		{
			MessageBox(NULL,"Sorry, only 16 and 32 bpp videomodes are supported in this release.","error",MB_OK);
			return 1;
		}

		// set cooperative level
		hres=g_pDD2->SetCooperativeLevel(hwin,DDSCL_NORMAL);
		if (hres!=DD_OK)
		{
			MessageBox(NULL,"error","unable to set cooperative level",MB_OK);
			return 1;
		}

		// Create the primary surface
	    DDSURFACEDESC ddsd1;
		memset(&ddsd1,0,sizeof(ddsd1));
		ddsd1.dwSize=sizeof(ddsd1);

		ddsd1.dwHeight=dimy;
		ddsd1.dwWidth=dimx;

		ddsd1.dwFlags=DDSD_CAPS;
		ddsd1.ddsCaps.dwCaps=DDSCAPS_PRIMARYSURFACE;

		hres=g_pDD2->CreateSurface(&ddsd1,&g_pDD2SPrimary,NULL);
		if (hres != DD_OK)
		{
			MessageBox(NULL,"error","primary surface",MB_OK);
			return 1;
		}
 
		// back buffer
		memset(&ddsd1,0,sizeof(ddsd1));
		ddsd1.dwSize=sizeof(ddsd1);
		ddsd1.dwFlags=DDSD_CAPS|DDSD_WIDTH|DDSD_HEIGHT;
		ddsd1.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN;

		if (gui->guiinfo.usesysmemory==1)
		{
		    ddsd1.ddsCaps.dwCaps|=DDSCAPS_SYSTEMMEMORY; 
		}
		else
		{
		    ddsd1.ddsCaps.dwCaps|=DDSCAPS_VIDEOMEMORY; 
		}

		if (videomode==1)
		{
			ddsd1.dwWidth=dimx/2;
			ddsd1.dwHeight=dimy/2;
		}
		else
		{
			ddsd1.dwWidth=dimx;
			ddsd1.dwHeight=dimy;
		}

		hres=g_pDD2->CreateSurface(&ddsd1,&g_pDD2SBack,NULL);
		if (hres != DD_OK)
		{
			MessageBox(NULL,"error","secondary surface",MB_OK);
			return 1;
		}

		// clipper
		typedef HRESULT (WINAPI *DDCreateClipperFun) ( DWORD dwFlags, LPDIRECTDRAWCLIPPER FAR *lplpDDClipper, IUnknown FAR *pUnkOuter );
		IDirectDrawClipper *pddcClipper=NULL;
		DDCreateClipperFun DDCreateClipper=NULL;

		DDCreateClipper=(DDCreateClipperFun)GetProcAddress(hdll,"DirectDrawCreateClipper");
		if (DDCreateClipper!=NULL)
		{
			hres=DDCreateClipper(0,&pddcClipper,NULL);
			if (hres!=DD_OK)
			{
				MessageBox(0,"error","creating clipper",MB_OK);
				return 1;
			}
		}

		if (pddcClipper!=NULL)
		{
			hres=pddcClipper->SetHWnd(0,hwin);
			if (hres==DD_OK)
			{
				g_pDD2SPrimary->SetClipper(pddcClipper);
				pddcClipper->Release();
			}
			else
			{
				MessageBox(0,"error","setting clipper",MB_OK);
				return 1;
			}
		}
	}

	return 0;
}

// get HWND

HWND videowin::getHwnd()
{
	return hwin;
}

// re-init display

int reinitDisplay(int videotype)
{
	return 0;
}

//  freeDisplay

void videowin::free(unsigned long int** video)
{
	unsigned long int* vb=*video;
	delete [] vb;

	if ((g_videomode==0) || (g_videomode==1) || (g_videomode==3))
	{
		if (g_videomode==0)
		{
			g_pDD2->SetDisplayMode(oldresX,oldresY,oldresBPP, 0, 0);
		}

		if (g_pDD2 != NULL)
		{
			if (g_pDD2SPrimary != NULL)
			{
				g_pDD2SPrimary->Release();
				g_pDD2SPrimary = NULL;
			}

			g_pDD2->Release();
			g_pDD2 = NULL;
		}

        FreeLibrary(hdll);
	}
}
